@echo off
if defined _SQS_ALONE setlocal
if not defined _CALLER set _CALLER=%~n1

:: ============================================================================
:: HINWEIS: Lokale Settings, die den Prefix "SQS_" haben werden beim Start
::          unserer Programme ausgewertet und verwendet, wenn Sie nicht durch
::          Aufrufparameter berschrieben werden.
:: ============================================================================
:: Ist der erste Parameter ein '--run' wird ein Alias aufgerufen
:: ============================================================================
call :RunAlias %*
if defined _SQS_ALIAS_CALLED goto :EOF

:: ============================================================================
:: Wird dieser Batch recursive aufgerufen, wird das erneuete Setzen der Para-
:: meter verhindert, es sei den der erste Parameter ist '-fi' (force input)
:: ============================================================================
call :CheckRecursiveCall %*
if defined _SQS_FIRST_TIME goto ENDE
set _SQS_FIRST_TIME=1
:: ============================================================================
:: ansonsten starte die normale Verarbeitung
:: ============================================================================
call :BatchInit %*

if defined _SQS_HELP_ONLY call :Usage&goto ENDE

if defined _SQS_CONFIGURE_TPA_SERVER call :Debug : TPA configuration will be set here!

:: ============================================================================
:: Auswertung der installierten Parameter
:: mit diesen Parametern werden die Defaults berschrieben
:: Hinweis: es werden keine semantischen Fehler entdeckt!
:: ============================================================================
call :ChooseContextEnv INST_ENV "%SQS_NL_CONFIG_PATH%"
if defined _SQS_USE_NO_CONTEXT goto DontSetLocalEnv
if not defined INST_ENV   call :ShowMessage No readable environmen configuration found in '%_SQS_CONF_PATH%'! Cancel startup...&set __SQS_EXIT=1&goto ENDE
if not defined SQS_SERVER_CONTEXT call :ShowMessage No environment choosen! Cancel startup...&set __SQS_EXIT=1&goto ENDE
if not exist "%INST_ENV%" call :ShowMessage Environment file '%INST_ENV%' for choosen environment '%SQS_SERVER_CONTEXT%' does not exist! Cancel startup...&set __SQS_EXIT=1&goto ENDE
if exist "%INST_ENV%" set SQS_SERVER_CONTEXT_FILE=%INST_ENV%&call "%INST_ENV%"
:DontSetLocalEnv
call :TPAConfig "%INST_ENV%"

:: ============================================================================
:: Zweite Auswertung der bergebenen Parameter:
:: die bergebenen Parameter knnen vorher gesetzte Werte berschrieben
:: Hinweis: es werden keine semantischen Fehler entdeckt!
call :DebugHeader 2. Analyse %*
set _BOOTSTRAP=
call Analyse.bat %*

:: Verbose Mode setzen, wenn er erkannt wird
if defined SQS_VERBOSE (
	if defined _SQS_ADD_PARAMS set _SQS_ADD_PARAMS=%_SQS_ADD_PARAMS% -verbose %SQS_VERBOSE%
	if not defined _SQS_ADD_PARAMS set _SQS_ADD_PARAMS=-verbose %SQS_VERBOSE%
)

if defined SQS_NO_DOMAIN_CHECK call :Debug : Domain check is switched off!

:: Settings fr den Testfall
if defined _SQS_TEST call :TestSettings

:: Noch mal durchlaufen, damit die zusammengesetzten Variablen aktualisiert werden.
call :SetAppDefaults

:: ============================================================================
:: Parameter fr Serverkontext
set PSQS_SERVER_CONTEXT=-ServerContext %SQS_SERVER_CONTEXT%
call :Debug : Resulting environment: '%SQS_SERVER_CONTEXT%'

:: ============================================================================
:: berprfe soweit wie mglich die Konsistenz der aktuellen Umgebung
call :SetDBNames
call :CheckJava
call :CheckLogging
call :CheckLicense
call :CheckLanguage
call :CheckTCS
call :CheckDBParams
call :CheckORBParams
call :CheckCOMEnv
call :CheckPath
call :CheckProcessNumber
call :CheckTPA
call :StartDemo

:ENDE
if defined SQS_PREFER_HOST call :SetPreferHostnameInIOR true
if defined SQS_PREFER_IP   call :SetPreferHostnameInIOR false
if defined SQS_SHOW_IORS   call :ShowExistingIORs

:: @echo on
call :ShowEnvironment
:: ============================================================================
:: Platz fr Aufrumarbeiten der lokalen Batches
:: ============================================================================
if defined _SQS_ALONE endlocal
:: Beende den Batch
call :DebugHeader %_CALLER%
goto :EOF

:DeleteTempVars
	:: Loeschen aller temporren Variablen, Namen beginnen mit mindestem einem Underscore '_'
	for /f "delims==" %%i in ('set _') do if %%~i NEQ _SQS_FIRST_TIME if %%~i NEQ _SQS_DEBUG call :Debug : Delete '%%~i' (%%%%i%%)
	::&set "%%i="
goto :EOF

:: ============================================================================
:: ============================================================================
:: Startbereich fr lokale Prozeduren
:: ============================================================================
:: ============================================================================

:BatchInit
	call :DebugHeader %~0
	:: Zeitstempel vom Start merken
	call :GetTimeString _STARTTIME
	:: Die mglichen Aliases initialisieren
	call :InitAliases

	:: ============================================================================
	:: Merke dir vorsorglich das Startverzeichnis und wechsele fr die nachfolgen-
	:: den Aktionen ins Ausfhrungsverzeichnis
	:: ============================================================================
	set _SQS_START_DIR=%CD%
	call :GetPath _SQS_START_DIR "%_SQS_START_DIR%"
	call :GetPath _SQS_EXECUTABLE_PATH "%~dp0"
	pushd "%_SQS_EXECUTABLE_PATH%" 1> nul 2>&1

	call :Debug : Actual working dir: '%CD%'
	
	
	:: Zeigt an, ob kein Kontext selektiert wurde
	:: Anhand der Information kann man entscheiden, ob man mit dem Default 
	:: weitermachen mchte oder ob man abbricht.
	set _SQS_NO_CONTEXT_SELECTED=
	:: Behebt Fehler im Erstellen einer Umgebung aus dem Admin Client
	:: Initialisieren der Variablen entfernt ungewnschten vererbten Wert eines
	:: Vaterprozesses, der evtl. in einer anderen Umgebung gestartet wurde
	set "SQS_SERVER_CONTEXT_FILE="

	set _SQS_HELP_ONLY=
	set _SQS_SHOW_WARNIG=1

	:: ============================================================================
	:: Erste Auswertung der bergebenen Parameter zur Vorauswahl des Kontextes:
	set _BOOTSTRAP=1
	call :DebugHeader 1. Analyse %*
	call Analyse.bat %*
	set _BOOTSTRAP=
	:: s. 'CORBConfiguration::VariableInSet(...)' zustzlicher Prefix der bei
	:: 'prepare' eines Servers bercksichtigt werden muss. Kann in der Env.*.bat
	:: ueberschrieben werden.
	if not defined SQS_ENVVAR_PREFIXLIST set SQS_ENVVAR_PREFIXLIST=PROGRAM

	:: ============================================================================
	:: Hier wird sich gemerkt, ob ein Kontext von aussen gesetzt wurde
	if defined SQS_SERVER_CONTEXT set _SQS_FORCE_CONTEXT=1

	if defined _SQS_SHOW_HEADER call :ShowHeader %*
	if defined _SQS_SILENT set _SQS_SHOW_WARNIG=
	call :Debug : Called: %_CALLER% %*

	call :SetAppDefaults

goto :EOF

:ShowMessage
	if "%~1" EQU "" goto :EOF
	call :Error : %*
	if defined _SQS_FORCE goto :EOF

	echo msgbox "%*", vbExclamation, "Cancel '%_CALLER%'...">"%TEMP%\msg.vbs"
	if "%ERRORLEVEL%" EQU "0" "%TEMP%\msg.vbs"
	del "%TEMP%\msg.vbs" 1> nul 2>&1
goto :EOF
	: Alternativ zu VBS
	if not exist InfoViewer.exe goto :EOF
	echo %*>"%TEMP%\SQSError.txt"
	call InfoViewer "%TEMP%\SQSError.txt"
	del "%TEMP%\SQSError.txt" 1> nul 2>&1
goto :EOF

:RunAlias
	:: ============================================================================
	:: Benutzung interner Prozeduren abprfen
	:: ============================================================================
	set __RUN_PARAMS=
	set _SQS_ALIAS_CALLED=
	:: Wenn der erste Parameter ein "--run" ist, wird ein call auf die restlichen
	:: Parameter ausgefhrt (Modulariesierung der Batches)
	if "%~1" NEQ "--run" goto :EOF
	:loop
	if "%~2" NEQ "" set __RUN_PARAMS=%__RUN_PARAMS% %2&shift&goto :loop
	
	:: wurden Parameter angegeben?
	if not defined __RUN_PARAMS goto :EOF
	
	set _SQS_ALIAS_CALLED=1
	:: call :Debug : %__RUN_PARAMS%
	call %__RUN_PARAMS%
goto :EOF

:CheckRecursiveCall
	:: Erzwinge die Initialisierung mit -fi (='force initialization') als erstem Parameter
	if "%~1" EQU "-fi" set _SQS_FIRST_TIME=

	:: Vorzeitige Erkennung des Debug Flags, damit die Ausgaben mglichst frh starten
	if "%~1" EQU "-d" set _SQS_DEBUG=1
	if "%~2" EQU "-d" set _SQS_DEBUG=1

	if not defined _SQS_FIRST_TIME goto :EOF

	:: Java auf jeden Fall noch mal checken bei verkapselten Aufrufen (warum???)
	call :CheckJava
	call :Debug : More than one call of '%_CALLER%' will be ignored!
goto :EOF

:: ============================================================================
:: Auswahl des gewnschten Kontextes wenn ntig
:: ============================================================================
:ChooseContextEnv
	call :DebugHeader %~0 %*
	set _SQS_INVALID_CONTEXT=
	: Falls kein Kontext genommen werden soll werden nur Defaults benutzt
	if defined _SQS_USE_NO_CONTEXT call :Debug : No context neccessary.&set %1=&goto :EOF

	set _SQS_CONF_PATH=%~2
	: berprfe, ob das GUI vorhanden ist um die Kontextliste anzuzeigen
	set _SQS_SELECT_GUI="%_SQS_EXECUTABLE_PATH%\SelectContext.exe"
	if defined _SQS_NO_GUI_SELECT set "_SQS_SELECT_GUI="
	if not defined _SQS_NO_GUI_SELECT if not exist %_SQS_SELECT_GUI% set "_SQS_SELECT_GUI="

	: Falls von aussen ein Kontext bergeben wurde, nimm ihn auf jeden Fall
	if defined _SQS_FORCE_CONTEXT call :ForceContextFile %1&goto :EOF

	: Ansonsten schau nach, welche Kontexte konfiguriert sind
	set COUNTER=0
	set _ENV_FILE=%_SQS_CONF_PATH%\Env.*.bat
	for %%a in ("%_ENV_FILE%") do call :SplitName "%%a"
	:: call :Debug : Environments found: %COUNTER%
	if %COUNTER% EQU 0 set %1=%_SQS_CONF_PATH%\Env.%SQS_SERVER_CONTEXT%.bat
	if %COUNTER% EQU 1 set %1=%_SQS_CONF_PATH%\Env.%_CONTEXT_LIST%.bat&set _CONTEXT=%_CONTEXT_LIST%
	if %COUNTER% GTR 1 call :ContextChoice %_CONTEXT_LIST%
	if %COUNTER% GTR 1 set %1=%_SQS_CONF_PATH%\Env.%_CONTEXT%.bat
	if defined _CONTEXT set SQS_SERVER_CONTEXT=%_CONTEXT%
goto :EOF

:ForceContextFile
	set %1=%_SQS_CONF_PATH%\Env.%SQS_SERVER_CONTEXT%.bat
	if not defined SQS_SERVER_CONTEXT_FILE goto :EOF
	if not exist "%SQS_SERVER_CONTEXT_FILE%" goto :EOF
	set %1=%SQS_SERVER_CONTEXT_FILE%
goto :EOF

:SplitName
	:: probiere, ob die Datei lesbar ist:
	type %1 1>nul 2>&1
	:: Datei wird nur in Liste aufgenommen, wenn sie lesbar ist
	if "%ERRORLEVEL%" NEQ "0" call :Warning Environment '%~nx1' not readable.&goto :EOF
	
	set /a COUNTER=%COUNTER% + 1
	set __FILE_NAME=%~n1
	for /f "tokens=2,* delims=." %%i in ('echo %__FILE_NAME%') do (
		call :Debug : Environment from '%~1' = '%%i'
		call :AddToList %%i @ _CONTEXT_LIST %_CONTEXT_LIST%
	)
goto :EOF

:ContextChoice
	if defined _SQS_NO_INTERACTIVE goto :EOF
	if defined _SQS_SELECT_GUI (
		call :ContextChoiceGUI _SQS_SELECT_GUI
		: Falls SELECT_GUI zurckgesetzt wurde hat das mit
		: dem GUI nicht funktioniert und es geht weiter
		: ueber Konsole
		if defined _SQS_SELECT_GUI goto :EOF
	)
	echo There is no environment selected!
	echo Please choose one possible environment of the following list:
	set CI=%COUNTER%
	set CJ=1
	:NEXT_ONE
	if %CI% GTR 0 call :EchoContext @ %CJ% %_CONTEXT_LIST% _NUMBERS %_NUMBERS%
	set /a CI=%CI%-1
	set /a CJ=%CJ%+1
	if %CI% GTR 0 goto NEXT_ONE
	choice /C:%_NUMBERS%
	call :GetMember @ %ERRORLEVEL% %_CONTEXT_LIST% _CONTEXT
goto :EOF

:ContextChoiceGUI
	call :Debug : Environments: "%_CONTEXT_LIST:@= %"
	call :BuildTempFile _CONTEXT_OUT Context
	: Wenn kein File angelegt werden konnte -> abbrechen!
	if not defined _CONTEXT_OUT set %1=&goto :EOF
	call :Debug : Environment output goes to: "%_CONTEXT_OUT%"
	call %_SQS_SELECT_GUI% %_CONTEXT_LIST:@= % > "%_CONTEXT_OUT%"
	for /f %%i in (%_CONTEXT_OUT%) do set _CONTEXT=%%i
	if not defined _CONTEXT set _SQS_NO_CONTEXT_SELECTED=1
	del "%_CONTEXT_OUT%" 1> nul 2>&1
goto :EOF

:EchoContext
	for /f "tokens=%2 delims=%1" %%i in ('echo %3') do set _TEXT=%%i
	echo ^ ^ %2. %_TEXT%
	if defined %4 set %4=%5%2
	if not defined %4 set %4=%2
goto :EOF

:AddToList
	if not defined %3 set %3=%1&goto :EOF
	: Sonderbehandlung von ";", wegen extremen Quotingproblemen
	if "%2" NEQ "SEMIKOLON" set %3=%4%2%1&goto :EOF
	if "%2" EQU "SEMIKOLON" set %3=%4;%1
goto :EOF

:GetMember
	for /f "tokens=%2 delims=%1" %%i in ('echo %3') do set %4=%%i
goto :EOF

:BuildTempFile
	call :BuildTimeStamp _TIMESTAMP
	call :GetWriteablePath _TEMP_PATH
	set %1=%_TEMP_PATH%\~~%~2-%_TIMESTAMP%.dat
	call :MakeShortPath %1 "%%%1%%"
	call :Debug : %0: %1 = '%%%1%%'
goto :EOF

:BuildTimeStamp
	: Timestamp aus aktuellem Datum und Uhrzeit erzeugen.
	: Entferne hierzu alle Doppelpunkte, Kommas und Leerzeichen
	set __TIMESTAMP=%DATE: =%%TIME: =%
	if "%~2" NEQ "" (
		if /i "%~2" EQU "d"  set __TIMESTAMP=%DATE: =%
		if /i "%~2" EQU "t"  set __TIMESTAMP=%TIME: =%
		if /i "%~2" EQU "td" set __TIMESTAMP=%TIME: =%%DATE: =%
	)
	set __TIMESTAMP=%__TIMESTAMP::=%
	set __TIMESTAMP=%__TIMESTAMP:,=%
	set __TIMESTAMP=%__TIMESTAMP:.=%
	set %1=%__TIMESTAMP:/=-%
goto :EOF

:GetWriteablePath
	call :TestWriting TEMP "%TEMP%" %1
	if defined %1 goto :EOF
	call :TestWriting TMP "%TMP%" %1
	if defined %1 goto :EOF
	call :TestWriting TMPDIR "%TMPDIR%" %1
	if defined %1 goto :EOF
	call :TestWriting APPDATA "%APPDATA%" %1
	if defined %1 goto :EOF
	call :TestWriting CD "%CD%" %1
	if defined %1 goto :EOF
	if not defined %1 (
		call :Error : -----------------------------------------------------------
		call :Error : No place found where I can write information to!
		call :Error : So can't write any output to a file!
		call :Error : Please set one of the following environment variables 
		call :Error : to a writeable directory for user '%USERNAME%' or run
		call :Error : this skript with the user who had permission to write
		call :Error : to 'TEMP', 'TMP', 'TEMPDIR', 'APPDATA' or the current
		call :Error : directory '%CD%'
		call :Error : -----------------------------------------------------------
	)
goto :EOF

:TestWriting
	if not defined %1 goto :EOF
	if not exist %2 goto :EOF
	set __TEMPPATH=%~2\SQS
	call :Debug : Checking for writeable directory '%__TEMPPATH%'...
	if not exist "%__TEMPPATH%" (
		md "%__TEMPPATH%" 1> nul 2>&1
		if %ERRORLEVEL% NEQ 0 set %3=
	)
	if not exist "%__TEMPPATH%" goto :EOF
	
	: Teste, ob ich auch ein File im Verzeichnis anlegen kann
	: erst dann, ist der Test erfolgreich und gibt den schreibbaren
	: Pfad zurck
	call :BuildTimeStamp __TMPFILE
	set __TMPFILE=%__TEMPPATH%\~~%__TMPFILE%.dat
	call :Debug : Try to create TempFile '%__TMPFILE%'...
	echo.>"%__TMPFILE%"
	if not exist "%__TMPFILE%" call :Error : Can not create file in '%__TEMPPATH%'!&set %3=
	:: call :DebugExecute dir /B "%__TEMPPATH%"
	del "%__TMPFILE%" 1> nul 2>&1
	:: call :DebugExecute dir /B "%__TEMPPATH%"
	set %3=%__TEMPPATH%
goto :EOF


:: ============================================================================
:: Test des Licensefiles fr den Managementserver, wenn er lokal installiert ist
:: ============================================================================
:CheckLicense
	if not defined LICENSE_CHECK goto :EOF
	if "%MS_INSTALLED%" NEQ "1" goto :EOF
	call :DebugHeader %0 %*
	:: Wegen Abwrtskompatibilitt (soll raus ab 11.0.500)
	if not defined _SQS_LICENSE_FILE set "_SQS_LICENSE_FILE=%SQS_LICENSE_FILE%"
	if not defined _SQS_PACKAGE_NAME set "_SQS_PACKAGE_NAME=%SQS_PACKAGE_NAME%"
	call :Debug : Check license "%_SQS_LICENSE_FILE%"...
	if exist "%_SQS_LICENSE_FILE%" goto LicenseChecked
	: Ueberpruefe, ob es die Form [<port>]@<host> hat, wenn nicht soll es wohl ein
	: Dateiname sein
	set _LIC_CHECK=%_SQS_LICENSE_FILE:@=%
	if "%_LIC_CHECK%" EQU "%_SQS_LICENSE_FILE%" (
		call :Warning WARNING : License file '%_SQS_LICENSE_FILE%' was not found!
		call :Remember
	)
	: Ansonsten teste, ob Lizenzserver aktive ist
	for /f "tokens=1,2 delims=@" %%i in ('echo %_SQS_LICENSE_FILE%') do set _PORT_RES=%%i&set _HOST_RES=%%j
	call :PortCheck PORT_ERROR %_PORT_RES% %_HOST_RES%
	if %PORT_ERROR% EQU 0 goto LicenseChecked
	call :Warning WARNING : License '%_SQS_LICENSE_FILE%' is actualy not valid:
	if %PORT_ERROR% EQU 1 (
		call :Warning "          License server host '%__HOST%' is not" RMQuotes
		call :Warning "          reachable at the moment." RMQuotes
	) else (
		call :Warning "          License server host '%__HOST%' does not" RMQuotes
		call :Warning "          listen on port '%__PORT%' at the moment." RMQuotes
	)
	call :Remember
	:LicenseChecked
	set PSQS_LICENSE_FILE=-LicenseFile "%_SQS_LICENSE_FILE%"
	set PSQS_PACKAGE_NAME=-PackageName %_SQS_PACKAGE_NAME%
	call :Debug : License file: '%_SQS_LICENSE_FILE%'
	call :Debug : Package name: '%_SQS_PACKAGE_NAME%'
goto :EOF

:Remember	
	call :Warning REMEMBER: Clients can not connect to an environment without a
	call :Warning "          valid and running license.!" RMQuotes
goto :EOF

:PortCheck
	if "%3" EQU "" set __HOST=%2&set __PORT=27000
	if "%3" NEQ "" set __HOST=%3&set __PORT=%2
	call :Debug : PingPort "%__HOST%" "%__PORT%"
	call PingPort "%__HOST%" "%__PORT%" 1> nul 2>&1
	set %1=%ERRORLEVEL%
goto :EOF

:: ============================================================================
:: Sprachangabe fr die Meldungen im Server und im Client
:: ============================================================================
:CheckLanguage
	call :DebugHeader %0 %*
	if /i "%_CALLER%" EQU "Client" set _SQS_LANGUAGE=%_SQS_TEMP_LANG%&goto NO_LANGUAGE
	set PSQS_LANGUAGE=
	set _SQS_LANGUAGE=
	if defined _SQS_SERVER_LANGUAGE (
		if /i "%_CALLER%" EQU "PrepareBGServer" set _SQS_LANGUAGE=%_SQS_SERVER_LANGUAGE%
		if /i "%_CALLER%" EQU "StartServer"     set _SQS_LANGUAGE=%_SQS_SERVER_LANGUAGE%
	)
	: Im Client Batchmode, sollen falsche Parameter erkannt werden, deshalb hier keine Korrektur.
	if defined SQS_BATCH_MODE set _SQS_LANGUAGE=%_SQS_TEMP_LANG%&goto NO_LANGUAGE
	
	if defined _SQS_SERVER_LANGUAGE if not defined _SQS_TEMP_LANG set _SQS_TEMP_LANG=%_SQS_LANGUAGE%
	: Wenn die Sprache nicht mit bergeben wurde wird der Applikationsdefault benutzt
	if not defined _SQS_TEMP_LANG goto NO_LANGUAGE
	call :Debug : Try to build language from '%_SQS_TEMP_LANG%'...
	if /i "%_SQS_TEMP_LANG%" EQU "D"      set _SQS_LANGUAGE=0x0407&goto NO_LANGUAGE
	if /i "%_SQS_TEMP_LANG%" EQU "DE"     set _SQS_LANGUAGE=0x0407&goto NO_LANGUAGE
	if /i "%_SQS_TEMP_LANG%" EQU "DEU"    set _SQS_LANGUAGE=0x0407&goto NO_LANGUAGE
	if /i "%_SQS_TEMP_LANG%" EQU "407"    set _SQS_LANGUAGE=0x0407&goto NO_LANGUAGE
	if /i "%_SQS_TEMP_LANG%" EQU "0x407"  set _SQS_LANGUAGE=0x0407&goto NO_LANGUAGE
	if /i "%_SQS_TEMP_LANG%" EQU "E"      set _SQS_LANGUAGE=0x0009&goto NO_LANGUAGE
	if /i "%_SQS_TEMP_LANG%" EQU "EN"     set _SQS_LANGUAGE=0x0009&goto NO_LANGUAGE
	if /i "%_SQS_TEMP_LANG%" EQU "ENU"    set _SQS_LANGUAGE=0x0009&goto NO_LANGUAGE
	if /i "%_SQS_TEMP_LANG%" EQU "9"      set _SQS_LANGUAGE=0x0009&goto NO_LANGUAGE
	if /i "%_SQS_TEMP_LANG%" EQU "0x9"    set _SQS_LANGUAGE=0x0009&goto NO_LANGUAGE
	if /i "%_SQS_TEMP_LANG%" EQU "0x09"   set _SQS_LANGUAGE=0x0009&goto NO_LANGUAGE
	if /i "%_SQS_TEMP_LANG%" EQU "0x009"  set _SQS_LANGUAGE=0x0009&goto NO_LANGUAGE
	:NO_LANGUAGE
	if defined _SQS_LANGUAGE (
		set PSQS_LANGUAGE=-Language %_SQS_LANGUAGE%
		call :Debug : Result for language is '%_SQS_LANGUAGE%'
	) else (
		call :Debug : No Language selected! Use application default!
	)
goto :EOF

:: ============================================================================
:: Test des TSSYS Pfads fr den Applicationserver, wenn er lokal installiert ist
:: ============================================================================
:CheckTCS
	if not defined _SQS_NEED_TCS goto :EOF
	call :DebugHeader %0 %*
	if exist "%_SQS_TSSYS%" goto TssysChecked
	call :Warning "WARNING: TSSYS path %_SQS_TSSYS% doesn't exist!" RMQuotes
	call :Warning "         Perhaps the '%_CALLER%' didn't found the TCS Integration!" RMQuotes
	goto TssysBad
	:TssysChecked
	set SQS_TCS_PATH=%_SQS_TSSYS%\bin
	set PSQS_TCS_PARAMS=-TCSPath "%_SQS_TSSYS%\bin"
	:TssysBad
	call :Debug : Used TSSYS path: "%_SQS_TSSYS%"
goto :EOF

:: ============================================================================
:: berprfung die allgemeinen und speziellen ORB Parameter
:: ============================================================================
:CheckORBParams
	if defined _SQS_NO_CORBA goto :EOF
	: ============================================================================
	: Falls gewuenscht, kann ein existierendes IT Environment genutzt werden,
	: wenn die Variablen _SQS_TAKE_EXISTING_IT und IT_PRODUCT_DIR von aussen
	: gestezt sind und das entsprechende Verzeichnis existiert
	: Falls ueber Parameter gesetzt, sind die entsprechenden '_IT' Variablen
	: gesetzt und haben immer Vorrang
	
	call :DebugHeader %0 %*
	
	call :SetDefaultPath IT_PRODUCT_DIR        "%SQS_INSTALL_DIR%\corba"
	call :SetDefault     IT_LICENSE_FILE       "%IT_PRODUCT_DIR%\etc\licenses.txt"
	call :SetDefaultPath IT_CONFIG_DIR         "%SQS_CONFIG_DIR%"
	call :SetDefaultPath IT_CONFIG_DOMAINS_DIR "%SQS_CONFIG_DIR%\domains"

	: ============================================================================
	: Domain Namen nur setzen, wenn die Konfiguration nicht ber 
	: "default-domain.cfg" gehen soll.
	: ============================================================================
	call :SetDefault IT_DOMAIN_NAME "%SQS_DOMAIN_NAME%"

	call :GetCOMetCacheDir SQS_COMET_CACHE_DIR
	if not defined _HAS_CHANGED goto DoNotShow
	call :Info : IT_CONFIG_DOMAINS_DIR set to local directory '%IT_CONFIG_DOMAINS_DIR%'
	call :Info : COMet Cache Dir set to local directory '%SQS_COMET_CACHE_DIR%'
	echo.
	:DoNotShow
	if defined SQS_COMET_CACHE_DIR (
		call :Debug ": COMet Cache Dir  : '%SQS_COMET_CACHE_DIR%'" RMQuotes
		if not exist "%SQS_COMET_CACHE_DIR%" call :Warning : WARNING: Configured SQS_COMET_CACHE_DIR '%SQS_COMET_CACHE_DIR%' does not exist!
	)
	
	if defined IT_PRODUCT_DIR        if not exist "%IT_PRODUCT_DIR%" call :Warning IT_PRODUCT_DIR '%IT_PRODUCT_DIR%' is missing!
	if defined IT_CONFIG_DIR         if not exist "%IT_CONFIG_DIR%" call :Warning IT_CONFIG_DIR '%IT_CONFIG_DIR%' is missing!
	if defined IT_CONFIG_DOMAINS_DIR if not exist "%IT_CONFIG_DOMAINS_DIR%" call :Warning IT_CONFIG_DOMAINS_DIR '%IT_CONFIG_DOMAINS_DIR%' is missing!
	if defined IT_LICENSE_FILE       if not exist "%IT_LICENSE_FILE%" call :Warning IT_LICENSE_FILE '%IT_LICENSE_FILE%' is missing!
	if not defined IT_DOMAIN_NAME    if not exist "%IT_CONFIG_DOMAINS_DIR%\default-domain.cfg" call :Warning CORBA configuration is missing! Please set the right domain name or the right domain directory!
	: Angleich der internen zur externen Variablen
	if defined IT_CONFIG_DOMAINS_DIR set _SQS_DOMAIN_DIR=%IT_CONFIG_DOMAINS_DIR%

	:: policies:iiop:server_address_mode_policy:publish_hostname = "true";
	:: policies:well_known_addressing_policy:iiop:host = "HostName";
	:: policies:iiop:server_address_mode_policy:local_hostname = "HostName";

	: ============================================================================
	: Wenn ein Adaptername gesetzt ist, wird ber ein Programm versucht die dyna-
	: mische IP dazu herauszufinden. Wird sie gefunden, wird der Name, ber den
	: der Client erreichbar ist, auf diese IP gesetzt.
	: Der Parameter kann auch direkt mit -PublishedName gesetzt werden.
	: ============================================================================
	if defined _SQS_NET_ADAPTER_NAME call :GetIPAddress SQS_PUBLISHED_NAME

	if not defined SQS_PUBLISHED_NAME goto NoPublishedName
	call :GetMyNames SQS_PUBLISHED_NAME "%SQS_PUBLISHED_NAME%"
	set PSQS_PUBLISHED_NAME=-ORBpolicies:iiop:server_address_mode_policy:local_hostname %SQS_PUBLISHED_NAME% -ORBpolicies:iiop:server_address_mode_policy:publish_hostname true
	call :Info : Setting hostname as required to '%SQS_PUBLISHED_NAME%'
	:NoPublishedName
	
	: ============================================================================
	: mit "-PortRange" knnen die aktiven Ports des Clients festgelegt werden, das
	: sind die Ports, auf dem der Client die Notifications und das Lifeness-
	: management empfngt. Pro Client wird in der aktuellen Version ein Port be-
	: ntigt. Der Range sollte also mindestens so gro sein, wie die Anzahl der 
	: paralell zu startenden Clients maximal sein kann.
	: Ohne diesen Parameter ist die Portzuteilung dynamisch.
	: Format des Portrange: <port1>:<port2> wobei port2 grer oder gleich port1
	: sein muss.
	: Beispiel: -PortRange 22222:22333
	: ============================================================================
	if defined SQS_PORT_RANGE (
		set PSQS_PORT_RANGE=-ORBpolicies:iiop:server_address_mode_policy:port_range %SQS_PORT_RANGE% -ORBplugins:iiop:ip:reuse_addr false
		call :Debug : Setting listen port range as required to '%SQS_PORT_RANGE%'
	)
	if defined _SQS_FIXPORT (
		set PSQS_PORT_RANGE=%PSQS_PORT_RANGE% -ORBpolicies:well_known_addressing_policy:iiop:port %_SQS_FIXPORT%
		call :Debug : Setting single listen port as required to '%_SQS_FIXPORT%'
	)
	
	set _SQS_ORB_PARAMS=
	if defined IT_PRODUCT_DIR        set _SQS_ORB_PARAMS=%_SQS_ORB_PARAMS% -ORBproduct_dir "%IT_PRODUCT_DIR%"
	if defined IT_CONFIG_DIR         set _SQS_ORB_PARAMS=%_SQS_ORB_PARAMS% -ORBconfig_dir "%IT_CONFIG_DIR%"
	if defined IT_CONFIG_DOMAINS_DIR set _SQS_ORB_PARAMS=%_SQS_ORB_PARAMS% -ORBconfig_domains_dir "%IT_CONFIG_DOMAINS_DIR%"
	if defined IT_DOMAIN_NAME        set _SQS_ORB_PARAMS=%_SQS_ORB_PARAMS% -ORBdomain_name %IT_DOMAIN_NAME%
	if defined IT_LICENSE_FILE       set _SQS_ORB_PARAMS=%_SQS_ORB_PARAMS% -ORBlicense_file "%IT_LICENSE_FILE%"
	if defined PSQS_PORT_RANGE       set _SQS_ORB_PARAMS=%_SQS_ORB_PARAMS% %PSQS_PORT_RANGE%
	if defined PSQS_PUBLISHED_NAME   set _SQS_ORB_PARAMS=%_SQS_ORB_PARAMS% %PSQS_PUBLISHED_NAME%
	: Vorrbergehnede bergabe der ORB Parameter ber die allgemein 
	: benutze Parameter Variable
	: set _SQS_ADD_PARAMS=%_SQS_ORB_PARAMS% %_SQS_ADD_PARAMS%
	set IT_ADMIN=%IT_PRODUCT_DIR%\asp\%IT_PRODUCT_VER%\bin\itadmin.exe
	set IOR_DUMP=%IT_PRODUCT_DIR%\asp\%IT_PRODUCT_VER%\bin\iordump.exe
	
	if defined IT_PRODUCT_DIR (
		call :Debug ": Product directory: '%IT_PRODUCT_DIR%'" RMQuotes
		if not exist "%IT_PRODUCT_DIR%" call :Warning WARNING: Configured IT_PRODUCT_DIR '%IT_PRODUCT_DIR%' does not exist!
	)
	if defined IT_LICENSE_FILE (
		call :Debug ": ORB license file : '%IT_LICENSE_FILE%'" RMQuotes
		if not exist "%IT_LICENSE_FILE%" call :Warning WARNING: Configured IT_LICENSE_FILE '%IT_LICENSE_FILE%' does not exist!
	)
	if defined IT_CONFIG_DIR (
		call :Debug ": ORB config dir   : '%IT_CONFIG_DIR%'" RMQuotes
		if not exist "%IT_CONFIG_DIR%" call :Warning WARNING: Configured IT_CONFIG_DIR '%IT_CONFIG_DIR%' does not exist!
	)
	if defined IT_CONFIG_DOMAINS_DIR (
		call :Debug ": Domain directory : '%IT_CONFIG_DOMAINS_DIR%'" RMQuotes
		if not exist "%IT_CONFIG_DOMAINS_DIR%" call :Warning WARNING: Configured IT_CONFIG_DOMAINS_DIR '%IT_CONFIG_DOMAINS_DIR%' does not exist!
	)
	if defined IT_DOMAIN_NAME (
		call :Debug ": Domain name      : '%IT_DOMAIN_NAME%'" RMQuotes
		if not defined IT_CONFIG_DOMAINS_DIR (
			if not defined IT_CONFIG_DIR (
				if not defined IT_PRODUCT_DIR (
					set _DOMAIN_CFG=%ProgrammFiles%\iona\etc\domains\%IT_DOMAIN_NAME%.cfg
				) else (
					set _DOMAIN_CFG=%IT_PRODUCT_DIR%\etc\domains\%IT_DOMAIN_NAME%.cfg
				)
			) else (
				set _DOMAIN_CFG=%IT_CONFIG_DIR%\domains\%IT_DOMAIN_NAME%.cfg
			)
		) else (
			set _DOMAIN_CFG=%IT_CONFIG_DOMAINS_DIR%\%IT_DOMAIN_NAME%.cfg
		)
	) else (
		set IT_DOMAIN_NAME=default-domain
		set _DOMAIN_CFG=%IT_CONFIG_DOMAINS_DIR%\default-domain.cfg
	)
	if not exist "%_DOMAIN_CFG%" call :Warning WARNING: Configured IT_DOMAIN_NAME '%_DOMAIN_CFG%' does not exist!
	
	if defined SQS_SHORT_HOST_NAME   call :Debug ": Short name  : '%SQS_SHORT_HOST_NAME%'" RMQuotes
	if defined SQS_LONG_HOST_NAME    call :Debug ": Long name   : '%SQS_LONG_HOST_NAME%'" RMQuotes
	if defined SQS_IP4_HOST_ADDRESS  call :Debug ": IPv4 address: '%SQS_IP4_HOST_ADDRESS%'" RMQuotes
	if defined SQS_PUBLISHED_NAME 	 call :Debug ": Local name  : '%PSQS_PUBLISHED_NAME%'" RMQuotes
	if defined _SQS_NET_ADAPTER_NAME call :Debug ": Adapter name: '%_SQS_NET_ADAPTER_NAME%'" RMQuotes
	if defined SQS_PORT_RANGE		 call :Debug ": Port range  : '%SQS_PORT_RANGE%'" RMQuotes
goto :EOF

:: COMet Cache Dir aus aktuell gltiger CORBA Domain ermitteln
:: ansonsten auf Default setzen
:GetCOMetCacheDir
	setlocal
	set _HAS_CHANGED=
	call :Debug : Look in '%IT_CONFIG_DOMAINS_DIR%\%IT_DOMAIN_NAME%.cfg' for local COMet Cache file...
	if exist "%IT_CONFIG_DOMAINS_DIR%\%IT_DOMAIN_NAME%.cfg" for /f "tokens=2 delims=;= " %%i in ('grep LOCAL_COMET_CACHE_FILE "%IT_CONFIG_DOMAINS_DIR%\%IT_DOMAIN_NAME%.cfg"') do call :GetPath %~1 "%%~dpi"
	:: Alles gut
	if defined %~1 goto PathFound

	:: Wenn die Domaindatei auf einem UNC Pfad liegt und enthlt keinen gltigen Pfad fr 
	:: den COMet Cache, mach sie lokal und trage den Standard Pfad ein, damit COMet genutzt
	:: werden kann
	if "%IT_CONFIG_DOMAINS_DIR:~0,2%" EQU "\\" call :MakeLocalCopy %1
	call :Debug : IT_CONFIG_DOMAINS_DIR: '%IT_CONFIG_DOMAINS_DIR%'
	call :Debug : %~1 set to '%%%~1%%'
	:PathFound
	call set RESULT=%%%~1%%
	endlocal&call set %~1=%RESULT%&set IT_CONFIG_DOMAINS_DIR=%IT_CONFIG_DOMAINS_DIR%&set _HAS_CHANGED=%_HAS_CHANGED%
goto :EOF

:SetLocalPaths
	if defined _APPV_CLIENT goto AppVClient
	set LOCAL_DOMAIN_DIR=%SQS_DATA_ROOT%\etc\domains
	set LOCAL_CACHE_PATH=%SQS_DATA_DIR%\corba\%IT_DOMAIN_NAME%\dbs\COMet
	goto :EOF
	:AppVClient
	set LOCAL_DOMAIN_DIR=%CD%\..\..\..\etc\domains
	set LOCAL_CACHE_PATH=%CD%\..\..\..\var\corba\%IT_DOMAIN_NAME%\dbs\COMet
goto :EOF

:MakeLocalCopy
	set _HAS_CHANGED=1
	setlocal
	set REMOTE_DOMAIN_FILE=%IT_CONFIG_DOMAINS_DIR%\%IT_DOMAIN_NAME%.cfg

	call :SetLocalPaths
	call :Debug : Try to copy '%REMOTE_DOMAIN_FILE%' to '%LOCAL_DOMAIN_DIR%'...

	if not exist "%LOCAL_CACHE_PATH%" md "%LOCAL_CACHE_PATH%"
	if exist "%LOCAL_CACHE_PATH%" call :GetPath LOCAL_CACHE_PATH "%LOCAL_CACHE_PATH%"
	if not exist "%LOCAL_CACHE_PATH%" call :Warning Not possible to create local COMet cache directory '%LOCAL_CACHE_PATH%'&goto :EOF

	if not exist "%LOCAL_DOMAIN_DIR%" md "%LOCAL_DOMAIN_DIR%"
	if exist "%LOCAL_DOMAIN_DIR%" call :GetPath LOCAL_DOMAIN_DIR "%LOCAL_DOMAIN_DIR%"
	if not exist "%LOCAL_DOMAIN_DIR%" call :Warning Not possible to create local domain config directory '%LOCAL_DOMAIN_DIR%'&goto :EOF

	set LOCAL_DOMAIN_FILE=%LOCAL_DOMAIN_DIR%\%IT_DOMAIN_NAME%.cfg
	call :Debug : LOCAL_DOMAIN_FILE: '%LOCAL_DOMAIN_FILE%'

	:: Wirf die Zeile mit LOCAL_COMET_CACHE_FILE raus und ersetze sie durch eine lokale Definition
	:: Kopiere die Datei nur, wenn die lokale Datei lter ist
	:: robocopy.exe "%IT_CONFIG_DOMAINS_DIR%" "%LOCAL_DOMAIN_DIR%" "%IT_DOMAIN_NAME%.cfg" /XO /R:0 /W:0 1>nul 2>&1
	xcopy  "%REMOTE_DOMAIN_FILE%" "%LOCAL_DOMAIN_DIR%\" /C /H /R /Y /D 1>nul 2>&1
	set COPY_ERROR=%ERRORLEVEL%
	call :Debug : copy exit code: '%COPY_ERROR%'
	if "%COPY_ERROR%" NEQ "0" call :Info : Copy failed, so no local domain configuration possible ^(%COPY_ERROR%^)&set LOCAL_CACHE_PATH=&goto NOT_CHANGED
	fc "%REMOTE_DOMAIN_FILE%" "%LOCAL_DOMAIN_FILE%" 1>nul 2>&1
	set FC_ERROR=%ERRORLEVEL%
	call :Debug : file compare exit code: '%FC_ERROR%'
	:: Tue nur was, wenn wirklich kopiert wurde => Inhalt gleich
	if "%FC_ERROR%" NEQ "0" call :Info : Do not change an existing local domain configuration ^(file compare: %FC_ERROR%^)&goto NOT_CHANGED
	call :Info : Put local path '%LOCAL_CACHE_PATH%'
	call :Info :   to '%LOCAL_DOMAIN_FILE%'
	set "LOCAL_COMET_CACHE_FILE_SET="
	del "%LOCAL_DOMAIN_FILE%" 1> nul 2>&1
	for /f " usebackq tokens=1,*" %%i in (`type "%REMOTE_DOMAIN_FILE%"`) do call :CheckLine %%i %%j
	if not defined LOCAL_COMET_CACHE_FILE_SET echo LOCAL_COMET_CACHE_FILE = "%LOCAL_CACHE_PATH%\Typeman._dc";>>"%LOCAL_DOMAIN_FILE%"
	:NOT_CHANGED
	endlocal&set %~1=%LOCAL_CACHE_PATH%&if exist "%LOCAL_DOMAIN_FILE%" set IT_CONFIG_DOMAINS_DIR=%LOCAL_DOMAIN_DIR%
	echo.
	call :Debug : IT_CONFIG_DOMAINS_DIR: '%IT_CONFIG_DOMAINS_DIR%'
	call :Debug : %~1  : '%%%~1%%'
goto :EOF

:CheckLine
	set LINE=%~1
	:: Falls die Zeile kein 'LOCAL_COMET_CACHE_FILE' enthlt einfach wieder komplett reinschreiben
	if "%LINE%" EQU "%LINE:LOCAL_COMET_CACHE_FILE=%" echo %*>>"%LOCAL_DOMAIN_FILE%"&echo.>>"%LOCAL_DOMAIN_FILE%"&goto :EOF
	:: ansonsten neues 'LOCAL_COMET_CACHE_FILE' an die Stelle schreiben
	set "LOCAL_COMET_CACHE_FILE_SET=1"
	echo LOCAL_COMET_CACHE_FILE = "%LOCAL_CACHE_PATH%\Typeman._dc";>> "%LOCAL_DOMAIN_FILE%"
goto :EOF

:IsDomainActive
	set %~1=
	:: Falls der Check ausgeschaltet ist wird 'aktiv' angenommen...
	if defined SQS_NO_DOMAIN_CHECK set %~1=1&call :Debug : Real domain check is switched off&goto :EOF
	if not exist "%_DOMAIN_CFG%" goto :EOF
	call :Debug : Check if domain '%IT_DOMAIN_NAME%' is active...
	call "%IT_ADMIN%" scope list 1> nul 2>&1
	if %ERRORLEVEL% EQU 0 set %~1=1
	call :Debug2 : %IT_ADMIN% scope list (ExitCode: %ERRORLEVEL%)
goto :EOF

:GetMyNames
	if /i "%~2" NEQ "long" if /i "%~2" NEQ "short" if /i "%~2" NEQ "ipv4" if /i "%~2" NEQ "ipv6" goto :EOF
	set "PING_IP=-4"
	set "GREP_IP=IPv4"
	if /i "%~2" EQU "ipv6" set "PING_IP="&set "GREP_IP=IPv6"
	set %~1=
	for /f "tokens=1" %%i in ('hostname') do set SQS_SHORT_HOST_NAME=%%i
	
	call :GetItWithPing SQS_LONG_HOST_NAME SQS_IP4_HOST_ADDRESS "%SQS_SHORT_HOST_NAME%"
	call :CheckResult %1 %2
	call :Debug : %~0: %~1 = '%%%~1%%'
	if defined %~1 goto :EOF
	
	call :GetItWithNSLookup SQS_LONG_HOST_NAME SQS_IP4_HOST_ADDRESS "%SQS_SHORT_HOST_NAME%"
	call :CheckResult %1 %2
	call :Debug : %~0: %~1 = '%%%~1%%'
goto :EOF

:CheckResult
	if "%~2" EQU "long"  if defined SQS_LONG_HOST_NAME   set %~1=%SQS_LONG_HOST_NAME%
	if "%~2" EQU "short" if defined SQS_SHORT_HOST_NAME  set %~1=%SQS_SHORT_HOST_NAME%
	if "%~2" EQU "ipv4"  if defined SQS_IP4_HOST_ADDRESS set %~1=%SQS_IP4_HOST_ADDRESS%
	if "%~2" EQU "ipv6"  if defined SQS_IP6_HOST_ADDRESS set %~1=%SQS_IP4_HOST_ADDRESS%
goto :EOF

:GetItWithPing
	call :DebugHeader %~0: %*
	ping -a -n 1 %~3 1> nul 2>&1
	if "%ERRORLEVEL%" NEQ "0" goto :EOF
	for /f "usebackq tokens=1,2 delims=[]" %%i in (`ping -a -n 1 %PING_IP% %~3 ^| grep "\["`) do call set _LONG=%%i&call set _IP4=%%j
	call :Debug : PingResult: %_LONG% %_IP4%
	for %%i in (%_LONG%) do call set %~1=%%i
	if not defined PING_IP for /f "tokens=1,2,* delims=%%" %%i in ('echo %_IP4%') do call set %~2=%_IP4%&goto :EOF
	set _IP4=%_IP4:[=%
	set %~2=%_IP4:]=%
goto :EOF

:GetItWithNSLookup
	call :DebugHeader %~0: %*
	for /f "usebackq tokens=2" %%i in (`nslookup %~3 ^| grep -i Name:`) do call set %~1=%%i
	for /f "usebackq tokens=2" %%i in (`nslookup %~3 ^| grep -i Address:`) do call set %~2=%%i
	if defined %~2 goto :EOF
	for /f "usebackq tokens=2" %%i in (`nslookup %~3 ^| grep -i Addresses:`) do call set %~2=%%i
goto :EOF

:GetItWithIPConfig
	call :DebugHeader %~0: %*
	for /f "usebackq tokens=2" %%i in (`ipconfig /all ^| grep -i %GREP_IP%`) do call set %~1=%%i
goto :EOF

:: ============================================================================
:: berprfung der Datenbankparameter
:: ============================================================================
:CheckDBParams
	if defined _SQS_NO_DB goto :EOF
	: ============================================================================
	: Angabe des zu benutzenden DB Hosts (Default: LOCAL)
	: ============================================================================
	call :DebugHeader %0 %*
	if defined _SQS_DB_HOST set PSQS_DB_HOST=-DBHost %_SQS_DB_HOST%
	
	: ============================================================================
	: Benutze evtl. vorhandene Konfigurationsdatei bei den Poet-Clients
	: ============================================================================
	if exist "%SQS_DB_CONFIG_FILE%" goto DBChecked
	call :Warning WARNING: DB configuration file %SQS_DB_CONFIG_FILE% doesn't exist!
	:DBChecked
	set PSQS_DB_CONFIG_FILE=-DBConfigFile "%SQS_DB_CONFIG_FILE%"
	if defined _SQS_DB_HOST call :Debug : DB host: '%_SQS_DB_HOST%'
	if defined _SQS_DB_HOST call :Debug : DB port: '%_SQS_DB_PORT%'
	call :Debug : DB config file: '%SQS_DB_CONFIG_FILE%'
goto :EOF

:: ============================================================================
:: "GetPath 'PathName'" stellt den gewnschten Pfad als absoluten Pfad ohne
:: "\" am Ende zur Verfgung
:: ============================================================================
:GetPath
	set __REL_PATH=%3
	if not defined __REL_PATH set __REL_PATH=.
	: call :Debug : Gewuenschter Relativer Pfad: %__REL_PATH%
	set _COPY_PATH=%~dpnx2
	if "%_COPY_PATH:~-1,1%" EQU "\" set _COPY_PATH=%_COPY_PATH:~0,-1%
	call :Debug : %~0: '%_COPY_PATH%\%__REL_PATH%'
	pushd "%_COPY_PATH%\%__REL_PATH%" 1> nul 2>&1
	if "%ERRORLEVEL%" NEQ "0" call :Warning : Warning: Do not set '%1' to non existing path '%_COPY_PATH%'&goto :EOF
	set %1=%CD%
	popd 1> nul 2>&1
	call :MakeShortPath %1 "%%%1%%"
	call :Debug2 %0: %1 = '%%%1%%'
goto :EOF

:: ============================================================================
:: "GetAbsolutePath 'VarName' 'PathName'" stellt einen existierenden, relativen
:: Pfad als absoluten Pfad ohne "\" am Ende zur Verfgung
:: ============================================================================
:GetAbsolutePath
	set %1=
	if not exist %2 goto :EOF
	pushd %2 1> nul 2>&1
	if "%ERRORLEVEL%" NEQ "0" call :Error %0: %1 '%~2'&goto :EOF
	set %1=%CD%
	popd 1> nul 2>&1
	call :MakeShortPath %1 "%%%1%%"
	call :Debug2 %0: %1 = '%%%1%%'
goto :EOF

:: ============================================================================
:: "MakeShortPath 'Variablenname' 'PathName'" stellt den gewnschten Pfad als 
:: absoluten Pfad in der alten 8.3 Notation ohne Blanks und sonstige Sonder-
:: zeichen zur Verfgung
:: ============================================================================
:MakeShortPath
	if not defined _SQS_USE_SHORT_PATH goto :EOF
	:: UNC Pfade werden nicht gekuerzt
	set _PARAM=%~2
	if "%_PARAM:~0,2%" EQU "\\" call :Debug : Don't shorten UNC path.&goto :EOF

	: Diese Systemfunktion ist auf einigen OS Versionen fehlerhaft
	: deshalb wird sie durch ':SubstituteSFn' ersetzt
	: set __MAKE_SHORT_PATH=%~sf2
	set __MAKE_SHORT_PATH=%~2
	call :SubstituteSFn %1 "%__MAKE_SHORT_PATH:\=\" "%"
	: call :RepairShortPath %__MAKE_SHORT_PATH% %1
	call :Debug : %0: %1= '%%%1%%'
goto :EOF

:SubstituteSFn
	setlocal ENABLEEXTENSIONS
	set sfn=
	:myLoop
	if "%~2" EQU "" goto LoopStopped
	for %%A in ("%sfn%%~2") do set sfn=%%~sA
	shift /2
	goto myLoop
	:LoopStopped
	endlocal&set %~1=%sfn%
goto :EOF

:: ============================================================================
:: Korrigiert einen Fehler in der '~s' Directive, hierbei werden bis zu drei
:: Zeichen am Ende des Pfads abgeschnitten, da diese faelschlicherweise von
:: '~s' angehaengt werden (MS Bug).
:: Das wird hier korrigiert, in dem die Existenz des Pfades berprft wird,
:: ob ein solcher Fehler vorliegen knnte. Wenn ja werden bis zu drei Zeichen 
:: abgeschnitten, wenn dieser Pfad aber auch nicht existiert, wird die Variable 
:: nicht bernommen.
:: ============================================================================
:RepairShortPath
	set __REPAIR_SHORT_PATH=%~1
	: call :Debug : %0: Before '%__REPAIR_SHORT_PATH%'
	if exist "%__REPAIR_SHORT_PATH%" goto Success
	: Entferne bis zu drei Zeichen am Ende
	set __REPAIR_SHORT_PATH=%__REPAIR_SHORT_PATH:~0,-1%
	set __LAST=%__REPAIR_SHORT_PATH:~-1%
	if "%__LAST%" EQU "\" goto :EOF
	if exist "%__REPAIR_SHORT_PATH%" goto Success

	set __REPAIR_SHORT_PATH=%__REPAIR_SHORT_PATH:~0,-1%
	set __LAST=%__REPAIR_SHORT_PATH:~-1%
	if "%__LAST%" EQU "\" goto :EOF
	if exist "%__REPAIR_SHORT_PATH%" goto Success

	set __REPAIR_SHORT_PATH=%__REPAIR_SHORT_PATH:~0,-1%
	set __LAST=%__REPAIR_SHORT_PATH:~-1%
	if "%__LAST%" EQU "\" goto :EOF
	if not exist "%__REPAIR_SHORT_PATH%" call :Error Not existing short name '%~1' detected!&goto :EOF
	:Success
	set %2=%__REPAIR_SHORT_PATH%
	: call :Debug : %0: After '%__REPAIR_SHORT_PATH%'
goto :EOF

:: ============================================================================
:: "AppendPath 'PathName' Variable 'Aktueller Wert'"
:: erweitert die bergebene Varible um den uebergebenen Pfad, falls er existiert
:: ============================================================================
:AppendPath
	call :Debug : Try to append ^'%~1^'...
	if not exist %1 call :Error Don't append non existing directory '%~1'!&goto :EOF
	if defined %2 set %2=%~3;%~dpnx1
	if not defined %2 set %2=%~dpnx1
goto :EOF

:: ============================================================================
:: "PrependPath 'PathName' Variable 'Aktueller Wert'"
:: erweitert die bergebene Varible um den uebergebenen Pfad, falls er existiert
:: ============================================================================
:PrependPath
	call :Debug : Try to prepend '%~1'...
	if not exist %1 call :Error Don't prepend non existing directory '%~1'!&goto :EOF
	if defined %2 set %2=%~dpnx1;%~3
	if not defined %2 set %2=%~dpnx1
goto :EOF

:: ============================================================================
:: Falls notwendig wird hier berprft, ob eine Javaversion verfgbar ist und
:: falls eine minimale Version gewnscht wird, wird auch die Version berprft.
:: ============================================================================
:CheckJava
	: Wenn Java nicht bentigt wird, spar dir den Check
	if not defined _CALLER_NEED_JAVA if not defined _SQS_JAVA_MIN_VERSION goto :EOF
	call :DebugHeader %0 %*
	
	call :SetJavaDefaults
	if not defined _SQS_JAVA_EXE call :JavaError 2
	
	if defined _SQS_JAVA_MIN_VERSION call :CheckJavaVersion "%_SQS_JAVA_EXE%" _JAVA_VERSION_NOT_OK
	if defined _JAVA_VERSION_NOT_OK call :JavaError 2&goto :EOF
	
	if not defined SQS_JAVA_HOME call :Error No Java found!&goto :EOF
	call :GetPath SQS_JAVA_HOME "%SQS_JAVA_HOME%"
	call :Info HINT: Use java VM at location '%SQS_JAVA_HOME%'
	
	call :PrependPath "%SQS_JAVA_HOME%\bin" PATH "%PATH%"
	set JAVA_HOME=%SQS_JAVA_HOME%
	call :Debug : JavaHome: '%SQS_JAVA_HOME%'
goto :EOF


:: ============================================================================
:SetJavaDefaults
	set SQS_JAVA_VERSION=1.8.0
	: 1. Versuch: Der von aussen gesetzte Pfad
	: ----------------------------------------------------------------------------
	if not defined SQS_JAVA_HOME goto NEXT_TRY
	set _SQS_JAVA_EXE=%SQS_JAVA_HOME%\bin\java.exe
	if exist "%_SQS_JAVA_EXE%" goto :EOF
	call :JavaError 1
	:NEXT_TRY
	: 2 a Versuch: Die installierte Javaversion
	: ----------------------------------------------------------------------------
	set SQS_JAVA_HOME=%SQS_INSTALL_DIR%\OpenJava\%SQS_JAVA_VERSION%
	set _SQS_JAVA_EXE=%SQS_JAVA_HOME%\bin\java.exe
	if exist "%_SQS_JAVA_EXE%" goto :EOF
	call :JavaError 1
	: 2 b Versuch: Die installierte Javaversion (alt)
	: ----------------------------------------------------------------------------
	set SQS_JAVA_HOME=%SQS_INSTALL_DIR%\OpenJava
	set _SQS_JAVA_EXE=%SQS_JAVA_HOME%\bin\java.exe
	if exist "%_SQS_JAVA_EXE%" goto :EOF
	call :JavaError 1
	
	if not exist "%SQS_INSTALL_DIR%\..\java\%SQS_JAVA_VERSION%" goto NextJava
	: 3. Versuch: Die Javaversion fuer die QS Umgebung (irrelevant fr Installationen)
	: ----------------------------------------------------------------------------
	set SQS_JAVA_HOME=%SQS_INSTALL_DIR%\..\java\%SQS_JAVA_VERSION%
	set _SQS_JAVA_EXE=%SQS_JAVA_HOME%\bin\java.exe
	if exist "%_SQS_JAVA_EXE%" goto :EOF
	call :JavaError 1
	:NextJava
	if not exist "U:\ent\java\jdk\%SQS_JAVA_VERSION%" goto NextJava2
	: 4. Versuch: Die Javaversion aus der Entwicklungsumgebung (irrelevant fr Installationen)
	: ----------------------------------------------------------------------------
	set SQS_JAVA_HOME=U:\ent\java\jdk\%SQS_JAVA_VERSION%
	set _SQS_JAVA_EXE=%SQS_JAVA_HOME%\bin\java.exe
	if exist "%_SQS_JAVA_EXE%" goto :EOF
	call :JavaError 1
	:NextJava2
	if not defined JAVA_HOME goto :EOF
	: 5. Versuch: das evtl. vorhandene Environment
	: ----------------------------------------------------------------------------
	set SQS_JAVA_HOME=%JAVA_HOME%
	set _SQS_JAVA_EXE=%SQS_JAVA_HOME%\bin\java.exe
	if exist "%_SQS_JAVA_EXE%" goto :EOF
	call :JavaError 1
goto :EOF


:JavaError
	:: ============================================================================
	goto JAVA_ERROR%1
	:JAVA_ERROR1
	set /a _MY_TRY=%_MY_TRY%+1
	call :Info %_MY_TRY%: No java version available or found in '%SQS_JAVA_HOME%'
	goto :EOF
	:JAVA_ERROR2
	echo.
	echo : -----------------------------------------------------------------------------
	if not defined _SQS_JAVA_MIN_VERSION (
		echo : '%_CALLER%' require an installed java runtime!
		echo : There was no actual java version found! 
	)
	if defined _SQS_JAVA_MIN_VERSION (
		echo : '%_CALLER%' require at least java runtime version '%_SQS_JAVA_MIN_VERSION%' or higher!
		echo : Actual java version found was '%ACT_JAVA_VERSION%'! 
	)
	echo : Please set the SQS_JAVA_HOME environment variable or give 
	echo : the right directory as commandline parameter '-JavaHome ^<java-home-dir^>'
	echo : to this script!
	echo : -----------------------------------------------------------------------------
goto :EOF


:: ============================================================================
:CheckJavaVersion
	call :DebugHeader CheckJavaVersion
	set %2=
	set LOG_FILE=%TEMP%\~~JavaVersion.log
	call :Debug : %1 -version
	call %1 -version 1> %LOG_FILE% 2>&1
	for /f "usebackq tokens=3" %%i in (`type "%LOG_FILE%"`) do set ACT_JAVA_VERSION=%%~i&call :JavaVersion %%~i _MAJOR _MINOR _PATCH _BUILD&goto STEP_OUT
	:STEP_OUT
	del %LOG_FILE% 1> nul 2>&1
	call :Debug : Actual java version: '%_MAJOR%' '%_MINOR%' '%_PATCH%' '%_BUILD%'
	call :JavaVersion %_SQS_JAVA_MIN_VERSION% _MAJOR_MIN _MINOR_MIN _PATCH_MIN _BUILD_MIN
	call :Debug : Minimum java version: '%_MAJOR_MIN%' '%_MINOR_MIN%' '%_PATCH_MIN%' '%_BUILD_MIN%'
	if defined _MAJOR if defined _MAJOR_MIN if "%_MAJOR%" LSS "%_MAJOR_MIN%" goto NO_SUCCESS
	if defined _MAJOR if defined _MAJOR_MIN if "%_MAJOR%" GTR "%_MAJOR_MIN%" goto :EOF
	if defined _MINOR if defined _MINOR_MIN if "%_MINOR%" LSS "%_MINOR_MIN%" goto NO_SUCCESS
	if defined _MINOR if defined _MINOR_MIN if "%_MINOR%" GTR "%_MINOR_MIN%" goto :EOF
	if defined _PATCH if defined _PATCH_MIN if "%_PATCH%" LSS "%_PATCH_MIN%" goto NO_SUCCESS
	if defined _PATCH if defined _PATCH_MIN if "%_PATCH%" GTR "%_PATCH_MIN%" goto :EOF
	if defined _BUILD if defined _BUILD_MIN if "%_BUILD%" LSS "%_BUILD_MIN%" goto NO_SUCCESS
	goto :EOF
	:NO_SUCCESS
	set %2=1
goto :EOF

:JavaVersion
	: ============================================================================
	call :Debug : Java Version: '%1'
	for /f "tokens=1,2,3 delims=." %%a in ('echo %1') do set %2=%%a&set %3=%%b&set _REST=%%c
	for /f "tokens=1,2 delims=_" %%a in ('echo %_REST%') do set %4=%%a&set %5=%%b
goto :EOF

:: ============================================================================
:: Falls eine Processnummer bergeben wurde, sollte sie hier auf Lnge 4
:: mit fhrenden Nullen gefllt werden
:: ============================================================================
:CheckProcessNumber
	call :DebugHeader %0 %*
	if not defined _SQS_PROCESS_NUMBER goto :EOF
	call :GetNumberStrg 4 %_SQS_PROCESS_NUMBER% _SQS_PROCESS_NUMBER
goto :EOF

:: ============================================================================
:: Settings fuer TPA taetigen und ueberpruefen
:: ============================================================================
:CheckTPA
	call :DebugHeader %0 %*
	: Initialisierung durch Default
	: set SQS_TPA_SERVER=

	: Wurde ber Parameter oder Kontext Environment gesetzt
	:: call :SetDefault SQS_TPA_SERVER ""
	
	:: call :ConfigureTPAServer
	if defined SQS_TPA_SERVER call :Debug : Local used TPA server settings: '%SQS_TPA_SERVER%'
goto :EOF

:: ============================================================================
:: Pfade fr bentigte Executables: (nur setzen, wenn sie auch existieren)
:: ============================================================================
:CheckPath
	call :DebugHeader %0 %*
	: set _SQS_PATH=
	call :AppendPath "%SystemRoot%\system32" _SQS_PATH "%_SQS_PATH%"
	call :AppendPath "%SystemRoot%" _SQS_PATH "%_SQS_PATH%"
	call :AppendPath "%SystemRoot%\system32\Wbem" _SQS_PATH "%_SQS_PATH%"

	if defined _SQS_NO_CORBA goto NextPath
	call :AppendPath "%IT_PRODUCT_DIR%\%IT_PACKAGE_NAME%\%IT_PRODUCT_VER%\bin" _SQS_PATH "%_SQS_PATH%"
	call :AppendPath "%IT_PRODUCT_DIR%\bin" _SQS_PATH "%_SQS_PATH%"
	call :AppendPath "%IT_PRODUCT_DIR%\bin\COMet" _SQS_PATH "%_SQS_PATH%"
	call :AppendPath "%IT_PRODUCT_DIR%%_64DIR%\bin" _SQS_PATH "%_SQS_PATH%"
	:NextPath

	call :AppendPath "%_SQS_NL_PATH%\bin" _SQS_PATH "%_SQS_PATH%"
	call :AppendPath "%SQS_INSTALL_DIR%\common\lib" _SQS_PATH "%_SQS_PATH%"
	if not defined _APPV_CLIENT     call :AppendPath "%SQS_CONFIG_DIR%\bin" _SQS_PATH "%_SQS_PATH%"
	if not defined _SQS_ONLY_CLIENT call :AppendPath "%SQS_INSTALL_DIR%\%_SQS_DB_PACKAGE%\%_SQS_DB_VERSION%\bin" _SQS_PATH "%_SQS_PATH%"
	if not defined _SQS_ONLY_CLIENT call :AppendPath "%SQS_INSTALL_DIR%\%_SQS_DB_PACKAGE%\%_SQS_DB_VERSION%\bin%_64DIR%" _SQS_PATH "%_SQS_PATH%"
	if not defined _SQS_ONLY_CLIENT call :AppendPath "%SQS_INSTALL_DIR%\%_SQS_LIC_PACKAGE%\%_SQS_LIC_VERSION%\bin" _SQS_PATH "%_SQS_PATH%"
	if     defined _SQS_NEED_TCS    call :AppendPath "%_SQS_TSSYS%\bin" _SQS_PATH "%_SQS_PATH%"
	
	if not defined _SQS_APPEND_PATH if not defined _SQS_PREPEND_PATH set PATH=%_SQS_PATH%
	if defined _SQS_PREPEND_PATH set PATH=%PATH%;%_SQS_PATH%
	if defined _SQS_APPEND_PATH set PATH=%_SQS_PATH%;%PATH%
	
	:: Aus CheckORBParams entfernt, da Pfad gesetzt sein muss
	if defined _SQS_NO_CORBA goto NoCorbaCheck
	call :IsDomainActive _DOMAIN_IS_ACTIVE
	if not defined _DOMAIN_IS_ACTIVE call :Warning : WARNING: Domain '%IT_DOMAIN_NAME%' is not running!
	if not defined SQS_NO_DOMAIN_CHECK if defined _DOMAIN_IS_ACTIVE call :Debug : Domain '%IT_DOMAIN_NAME%' can be connected!
	:NoCorbaCheck
	
	call :Debug : Used Path: %PATH%
goto :EOF

:: ============================================================================
:: Parameter fr Logging setzen und berprfen
:: ============================================================================
:CheckLogging
	: ============================================================================
	: Verzeichnis fr Logdateien setzen:
	call :DebugHeader %0 %*
	set SQS_NL_LOG_PATH=%SQS_CONTEXT_DATA_ROOT%\nl-logs
	if not exist "%SQS_NL_LOG_PATH%" md "%SQS_NL_LOG_PATH%" 1> nul 2>&1
	: ============================================================================
	: Extrawnsche fuer Logging auswerten:
	set PSQS_LOG_FILE=
	if defined _SQS_LOG_FILE set PSQS_LOG_FILE=-LogFile "%_SQS_LOG_FILE%"
	set PSQS_APPEND_TO_LOG_FILE=
	if defined _SQS_APPEND_TO_LOG_FILE set PSQS_APPEND_TO_LOG_FILE=-AppendToLogFile %_SQS_APPEND_TO_LOG_FILE%
	set PSQS_NO_LOG_FILE=
	if defined _SQS_NO_LOG_FILE set PSQS_NO_LOG_FILE=-NoLogFile %_SQS_NO_LOG_FILE%
	
	
	: ============================================================================
	: Filter fr die Ausgabe von Meldungen
	: gueltige Werte: -VerboseLevel 0 - 0xF
	:                 -VerboseMode  0 - 0x7FFFFFFF
	if not defined _SQS_VA goto SetVerboseParam
	set SQS_VERBOSE_LEVEL=0xF
	set SQS_VERBOSE_MODE=0x7FFFFFFF
	:SetVerboseParam
	if defined _SQS_VAD set SQS_DEVELOPER=1
	if defined SQS_VERBOSE_LEVEL set PSQS_VERBOSE_LEVEL=-VerboseLevel %SQS_VERBOSE_LEVEL%
	if defined SQS_VERBOSE_MODE  set PSQS_VERBOSE_MODE=-VerboseMode %SQS_VERBOSE_MODE%
goto :EOF


:: ============================================================================
:: Setzt die bergebene Variable mit dem Wert einer temporren Variablen (hat
:: einen vorgegebenen Prefix)
:: Falls gewnscht und es sich bei dem Wert der Variablen um einen ber-
:: prfenswerten Datei oder Pfadnamen dreht, wird der Wert erst gesetzt, wenn
:: dieser Wert im Verzeiechnis existiert.
:: 	1. Name der Variablen
:	2. Namenscheck durchfhren [optional]
:: ============================================================================
:CheckVariable
	set _TEMP_VAR=__%1
	if not defined %_TEMP_VAR% goto :EOF
	for /f "tokens=1,* delims==" %%a in ('set %_TEMP_VAR%') do if /I "%%a" EQU "%_TEMP_VAR%" set _NEW_VALUE=%%b
	if "%2" EQU "" goto SetValue
	if not exist "%_NEW_VALUE%" goto :EOF
	:SetValue
	set %1=%_NEW_VALUE%
goto :EOF

:: ============================================================================
:: Wenn ein Netzwerkadapter angegeben wurde wird versucht die IP Adresse dieses
:: Adapters an den jeweiligen Prozess zu bergeben, damit er seine IOR fr den
:: Server damit versehen kann.
:: Diese Option kann genutzt werden, wenn viele Verbindungen aktiv sind 
:: und der Prozess auf der benutzten Verbindung keinen festen Namen, sondern nur
:: eine dynamische IP besitzt.
:: ============================================================================
:GetIPAddress
	: Nur wenn das notwendige Programm existiert und fehlerfrei ausgefhrt werden 
	: kann wird die bergebene Variable gesetzt.
	if not exist IPFinder.exe goto :EOF
	call IPFinder.exe -a "%_SQS_NET_ADAPTER_NAME%" 1> nul 2>&1
	if %ERRORLEVEL% NEQ 0 goto :SHOW_ERROR
	
	: Adapter gefunden...
	for /f "tokens=*" %%i in ('IPFinder.exe -a "%_SQS_NET_ADAPTER_NAME%"') do set %1=%%i
goto :EOF

:: ============================================================================
:SHOW_ERROR
	: Fehlerbehandlung
	: Logge Fehler zur besseren Nachverfolgung, wenn's geht im Standard 
	: Log-Verzeichnis
	: ============================================================================
	if defined _CALLER set _LOG_FILE=%_CALLER%Startup-%SQS_SERVER_CONTEXT%-%_STARTTIME%.log
	if not defined _CALLER set _LOG_FILE=ProcessStartup-%SQS_SERVER_CONTEXT%-%_STARTTIME%.log
	if exist "%SQS_NL_LOG_PATH%" set _LOG_FILE=%SQS_NL_LOG_PATH%\%_LOG_FILE%
	
	echo. > %_LOG_FILE%
	echo :: =========================================================>> %_LOG_FILE%
	echo :: Clientstart attempt from %DATE% %TIME%>> %_LOG_FILE%
	echo :: with adapter name '%_SQS_NET_ADAPTER_NAME%'>> %_LOG_FILE%
	echo :: =========================================================>> %_LOG_FILE%
	call IPFinder.exe -a "%_SQS_NET_ADAPTER_NAME%" 1>> %_LOG_FILE% 2>>&1
	
	echo Problems finding right network adapter "%_SQS_NET_ADAPTER_NAME%"
	type "%_LOG_FILE%"
	echo.
	
	if defined _SQS_FORCE goto :EOF
	: =========================================================
	: Erzeuge einen Bacth, der die Fehlermeldung anzeigt, falls
	: gewuenscht.
	: =========================================================
	set _BATCH=~~ShowProblem.bat
	if exist "%TEMP%"            set _BATCH=%TEMP%\%_BATCH%&goto TEMP_FILE_FOUND
	if exist "%TMP%"             set _BATCH=%TMP%\%_BATCH%&goto TEMP_FILE_FOUND
	if exist "%SQS_NL_LOG_PATH%" set _BATCH=%SQS_NL_LOG_PATH%\%_BATCH%&goto TEMP_FILE_FOUND
	echo Can't create temporary Batch!
	:TEMP_FILE_FOUND
	
	echo @echo off > %_BATCH%
	echo color cf >> %_BATCH%
	echo echo :: "%_LOG_FILE%" >> %_BATCH%
	echo echo :: --------------------------------------------------------------- >> %_BATCH%
	echo type "%_LOG_FILE%" >> %_BATCH%
	echo echo. >> %_BATCH%
	echo pause >> %_BATCH%
	call start "WARNING: Possible problem with parameter NetAdapterName" cmd /c %_BATCH%
	
	: type %_BATCH%
	: del %_BATCH% 2> nul 1>&2
goto :EOF

:: ============================================================================
:: Standardsettings lokal fr unsere Applikationen
:: ============================================================================
:SetAppDefaults
	call :DebugHeader %~0
	call :SetLocalEnv
	call :SetDefault _SQS_PRODUCT_MAJOR       11
	call :SetDefault _SQS_PRODUCT_MINOR       0
	call :SetDefault _SQS_PRODUCT_MAINTENANCE 7
	call :SetDefault _SQS_PRODUCT_PATCH       %SQS_PRODUCT_PATCH% "??"
	call :SetDefault _SQS_PRODUCT_VERSION     %_SQS_PRODUCT_MAJOR%.%_SQS_PRODUCT_MINOR%.%_SQS_PRODUCT_MAINTENANCE%
	call :SetDefault _SQS_API_VERSION         4.5
	
	call :SetDefault _SQS_PRODUCT_NAME       Expleo-Test/Professional
	call :SetDefault _SQS_PRODUCT_PACKAGE    nl
	call :SetDefault _SQS_CORBA_PACKAGE      corba
	call :SetDefault _SQS_DB_PACKAGE         oodb
	call :SetDefault _SQS_LIC_PACKAGE        flexlm
	call :SetDefault _SQS_CL_PACKAGE         cl
	call :SetDefault _SQS_DEFAULT_CONTEXT    ETP%_SQS_PRODUCT_VERSION:.=%
	call :SetDefault SQS_HOME_PAGE           https://tools.expleogroup.com
	call :SetDefault SQS_SUPPORT_MAIL_ADRESS support_etp@expleogroup.com
	
	: ============================================================================
	: allgemeine Basiseinstellungen und -pfade, die sich aktuell aus den
	: Konventionen ergeben oder aber von der Installation gesetzt werden
	: ============================================================================
	call :SetDefaultPath SQS_INSTALL_DIR "%_SQS_EXECUTABLE_PATH%\..\..\.."
	call :SetDefaultPath SQS_DATA_ROOT   "%SQS_DATA_ROOT%" "%SQS_INSTALL_DIR%"
	call :SetDefaultPath SQS_DATA_DIR    "%SQS_DATA_ROOT%\var"
	call :SetDefaultPath SQS_CONFIG_DIR  "%SQS_DATA_ROOT%\etc"
	call :SetDefault     SQS_CTX_ACCESS  "%SQS_CTX_ACCESS%" 1
		
	: ============================================================================
	: abgeleitete Verzeichnisse laut Produktstruktur
	: ============================================================================
	call :SetDefaultPath _SQS_NL_PATH       "%SQS_INSTALL_DIR%\%_SQS_PRODUCT_PACKAGE%\%_SQS_PRODUCT_VERSION%"
	call :SetDefaultPath _SQS_NL_DATA_PATH  "%SQS_DATA_DIR%"
	call :SetDefaultPath SQS_NL_CONFIG_PATH "%SQS_CONFIG_DIR%\%_SQS_PRODUCT_VERSION%"

	if exist "%SQS_NL_CONFIG_PATH%" goto NO_CHECK
	call :Warning Expected configuration directory '%SQS_NL_CONFIG_PATH%' is missing! 
	call :Warning Changing to default '%_SQS_EXECUTABLE_PATH%'!
	set SQS_NL_CONFIG_PATH=%_SQS_EXECUTABLE_PATH%
	:NO_CHECK
	
	: ============================================================================
	: abgeleitete Verzeichnisse fuer die Classic Komponenten
	: ============================================================================
	call :SetDefault     _SQS_CL_VERSION 6.6
	call :SetDefaultPath SQS_CL_PATH     "%SQS_INSTALL_DIR%\%_SQS_CL_PACKAGE%\%_SQS_CL_VERSION%"
	call :SetDefaultPath _SQS_TSSYS      "%SQS_CL_PATH%"
	
	: ============================================================================
	: Defaultsettings, die von der Installation geaendert werden knnen
	: ============================================================================
	: Serverkontext
	: wird von der Installation geaendert
	call :SetDefault SQS_SERVER_CONTEXT "%SQS_SERVER_CONTEXT%" %_SQS_DEFAULT_CONTEXT%
	
	: ============================================================================
	: Angabe des Lizenzdatei und des Lizenzpackages nur fuer den ManagementServer
	: notwendig: wird von der Installation geaendert
	call :SetDefault SQS_LICENSE_FILE "%SQS_CONFIG_DIR%\license.dat"
	call :SetDefault SQS_PACKAGE_NAME SQS_STD
	
	: ============================================================================
	: Angabe der Sprache, in der der Managementserver gestartet wird
	: wird von der Installation geaendert
	: call :SetDefault _SQS_LANGUAGE set _SQS_LANGUAGE=D
	
	: ============================================================================
	: Fr Datenbanken:
	set SQS_CONTEXT_DATA_ROOT=%_SQS_NL_DATA_PATH%\%SQS_SERVER_CONTEXT%
	set _SQS_DB_PATH=%SQS_CONTEXT_DATA_ROOT%\Repository
	set SQS_REPORT_TEMPL_DATA_ROOT=%SQS_CONTEXT_DATA_ROOT%\Report

	: ============================================================================
	: Angabe des Datenbank Konfigurationsfiles (alle Server)
	set SQS_DB_CONFIG_FILE=%SQS_CONFIG_DIR%\%SQS_SERVER_CONTEXT%\ptserver.cfg
	if not exist "%SQS_DB_CONFIG_FILE%" set SQS_DB_CONFIG_FILE=%SQS_CONFIG_DIR%\ptserver.cfg
	call :SetDefault SQS_DB_CONFIG_FILE "%SQS_DB_CONFIG_FILE%"
	
	: ============================================================================
	: Angabe des Templateverzeichnisses fr CreateNewContext
	call :SetDefault SQS_TEMPLATE_DIR "%_SQS_NL_PATH%\templates"

	: ============================================================================
	: Angabe des Report Verzeichnisses
	call :SetDefault SQS_REPORT_DIR "%_SQS_NL_PATH%\reports"
	
	: ============================================================================
	: Angabe des versionsabhngigen Lib-Verzeichnisses
	call :SetDefault _SQS_NL_LIBS "%_SQS_NL_PATH%\bin"
	
	: ============================================================================
	: Environment der benutzten CORBA Domain
	: wird von der Installation geaendert
	call :GetLocalHostname _SQS_LOCAL_HOST
	call :SetDefault _SQS_CORBA_HOST %_SQS_LOCAL_HOST%

	if defined _SQS_CORBA_BASE_PORT (
		set /a _SQS_CORBA_CFR_PORT=%_SQS_CORBA_BASE_PORT%+2
	)
	call :SetDefault _SQS_CORBA_CFR_PORT %_SQS_CORBA_CFR_PORT% 3077
	call :SetDefault SQS_DOMAIN_NAME_DEF "SQS-TEST_%_SQS_PRODUCT_VERSION:.=%"
	call :SetDefault IT_DOMAIN_NAME %_SQS_DOMAIN_NAME_DEF%
	call :SetDefault SQS_DOMAIN_NAME %IT_DOMAIN_NAME%
	:: wegen Abwrtskompatibilitt soll in 11.0.500 raus!
	set _SQS_DOMAIN_NAME=%SQS_DOMAIN_NAME%
	call :SetDefault _SQS_DEMO_DOMAIN_DEF "%_SQS_DOMAIN_NAME_DEF%-Demo"
	
	: ============================================================================
	: Angabe des DB Servers und dessen Port
	: wird von der Installation geaendert
	call :SetDefault _SQS_DB_HOST LOCAL
	call :SetDefault _SQS_DB_PORT 6001
	
	: ============================================================================
	: Filter fr die Ausgabe von Meldungen
	: gueltige Werte: -VerboseLevel 0 - 0xF
	:                 -VerboseMode  0 - 0xFFFFFFFF
	call :SetDefault SQS_VERBOSE_LEVEL ""
	call :SetDefault SQS_VERBOSE_MODE ""
	
	: ============================================================================
	:                  Festgelegte Variablen lt. Konvention
	: (abgeleitet von den Installationsvorgaben oder den bergebenen Parametern)
	: ============================================================================
	: SQS Java Home setzen notwendig fr CORBA Domain Konfiguration und AdminClient
	: aktuell installierte Java Runtime Version
	: AdminClient braucht ab der Version 8.0 die Java Runtime 1.5.0
	: ============================================================================
	: set _JAVA_MIN_VERSION=%SQS_JAVA_VERSION%
	set _JAVA_RT_VERSION=%SQS_JAVA_VERSION%
	
	: ============================================================================
	: Fr Namenskonvertierung von Rechnername (Default: Case sensitiver Vergleich):
	call :SetDefault SQS_NO_HOSTNAME_CONVERTION %SQS_NO_HOSTNAME_CONVERTION% 1

	: ============================================================================
	: Status der lokal installierten Komponenten
	call :SetDefault CORBA_INSTALLED %CORBA_INSTALLED% 0
	call :SetDefault CORBA_IS_SYSTEM %CORBA_IS_SYSTEM% 0
	call :SetDefault CORBA_ENABLED %CORBA_ENABLED% 0
	
	call :SetDefault POET_INSTALLED %POET_INSTALLED% 0
	call :SetDefault POET_IS_SYSTEM %POET_IS_SYSTEM% 0
	call :SetDefault POET_ENABLED %POET_ENABLED% 0
	
	call :SetDefault FLEXLM_INSTALLED %FLEXLM_INSTALLED% 0
	call :SetDefault FLEXLM_IS_SYSTEM %FLEXLM_IS_SYSTEM% 0
	call :SetDefault FLEXLM_ENABLED %FLEXLM_ENABLED% 0
	
	call :SetDefault MS_INSTALLED %MS_INSTALLED% 0
	call :SetDefault MS_IS_SYSTEM %MS_IS_SYSTEM% 0
	call :SetDefault MS_ENABLED %MS_ENABLED% 0
	call :SetDefault MS_IGNORE %MS_IGNORE%
	call :SetDefault AS_INSTALLED %AS_INSTALLED% 0
	call :SetDefault AS_IS_SYSTEM %AS_IS_SYSTEM% 0
	call :SetDefault AS_ENABLED %AS_ENABLED% 0
	call :SetDefault AS_IGNORE %AS_IGNORE%
	call :SetDefault API_INSTALLED %API_INSTALLED% 0
	call :SetDefault API_IS_SYSTEM %API_IS_SYSTEM% 0
	call :SetDefault API_ENABLED %API_ENABLED% 0
	call :SetDefault API_IGNORE %API_IGNORE%
	call :SetDefault LM_INSTALLED %LM_INSTALLED% 0
	call :SetDefault LM_IS_SYSTEM %LM_IS_SYSTEM% 0
	call :SetDefault LM_ENABLED %LM_ENABLED% 0
	call :SetDefault LM_IGNORE %LM_IGNORE%
	call :SetDefault IMP_XML_INSTALLED %IMP_XML_INSTALLED% 0
	call :SetDefault IMP_XML_IS_SYSTEM %IMP_XML_IS_SYSTEM% 0
	call :SetDefault IMP_XML_ENABLED %IMP_XML_ENABLED% 0
	call :SetDefault IMP_XML_IGNORE %IMP_XML_IGNORE%
	: set SQS_FEATURE_VERSION=10.2
	
	: ============================================================================
	: Setze Variablen, die von aussen nicht gesetzt sind, aber notwendig sind
	: Fr CORBA:
	call :SetDefault SQS_DOMAIN_DIR "%SQS_CONFIG_DIR%\domains"
	
	: ============================================================================
	: Bentigtes Produktenvironment fr Orbix:
	: ============================================================================
	set IT_PACKAGE_NAME=asp
	call :SetDefault IT_PRODUCT_VER 6.3
	
	: ============================================================================
	: Produktenvironment fr POET:
	call :SetDefault _SQS_DB_VERSION 14.0.0
	
	: ============================================================================
	: Produktenvironment fr FlexLM:
	call :SetDefault _SQS_LIC_VERSION 11.18
	
	: ============================================================================
	: Produktenvironment fr Crystal Reports:
	call :SetDefault _SQS_CRYSTAL_VERSION 11.0
	
	: ============================================================================
	: Namen der Executables
	: ============================================================================
	set _SQS_MS=ManagementServer
	set _SQS_AS=ApplicationServer
	set _SQS_API=APIServer
	set _SQS_LM=LicenseManager
	set _SQS_IMP_XML=ImportManagerXML
	
	set _SQS_MS_EXE=ManagementServer.exe
	set _SQS_AS_EXE=ApplicationServer.exe
	set _SQS_API_EXE=APIServer.exe
	set _SQS_LM_EXE=%_SQS_LM%.exe
	set _SQS_IMP_XML_EXE=ImportManagerXML.exe
	
	: ============================================================================
	: Produkt Namen der Serverkomponenten
	: ============================================================================
	set _SQS_MS_NAME=Management Server
	set _SQS_AS_NAME=Application Server
	set _SQS_API_NAME=Public API Server
	set _SQS_LM_NAME=License Manager
	set _SQS_IMP_XML_NAME=Import Manager XML
	
	: ============================================================================
	: Prozess Namen der Serverkomponenten
	: ============================================================================
	set _SQS_MS_PNAME=ManagementServer
	set _SQS_AS_PNAME=ApplicationServer
	set _SQS_API_PNAME=APIServer
	set _SQS_LM_PNAME=%_SQS_LM%
	set _SQS_IMP_XML_PNAME=ImportManagerXML
	
	: ============================================================================
	: NT Service Namen der Serverkomponenten
	: ============================================================================
	set _SQS_MS_SERV_NAME=%_SQS_MS%
	set _SQS_AS_SERV_NAME=%_SQS_AS%
	set _SQS_API_SERV_NAME=%_SQS_API%
	set _SQS_LM_SERV_NAME=%_SQS_LM%
	set _SQS_IMP_XML_SERV_NAME=%_SQS_IMP_XML%
	
	: ============================================================================
	: Logische Namen der Datenbanken (Default)
	: ============================================================================
	set _SQS_DEF_DB_MS=ManagementDB
	set _SQS_DEF_DB_AS=ApplicationDB
	set _SQS_DEF_DB_IMP_XML=ImportXML_DB
goto :EOF


:SetDBNames
	call :DebugHeader %0 %*
	set _SQS_DBPREFIX=%SQS_SERVER_CONTEXT%\
	set _SQS_DBPOSTFIX=_%SQS_SERVER_CONTEXT%
	
	: ============================================================================
	: Logische Namen setzen, wenn sie nicht von der Konfiguration gendert wurden
	: ============================================================================
	set _SQS_DB_MS=%_SQS_DEF_DB_MS%%_SQS_DBPOSTFIX%
	set _SQS_DB_AS=%_SQS_DEF_DB_AS%%_SQS_DBPOSTFIX%
	set _SQS_DB_IMP_XML=%_SQS_DEF_DB_IMP_XML%%_SQS_DBPOSTFIX%
goto :EOF

:: ============================================================================
:: Alles setzen, um einfacher testen zu knnen
:: ============================================================================
:TestSettings
	set CORBA_INSTALLED=1
	set CORBA_IS_SYSTEM=0
	set CORBA_ENABLED=0

	set POET_INSTALLED=1
	set POET_IS_SYSTEM=0
	set POET_ENABLED=0

	set FLEXLM_INSTALLED=1
	set FLEXLM_IS_SYSTEM=0
	set FLEXLM_ENABLED=0

	set MS_INSTALLED=1
	set MS_IS_SYSTEM=1
	set MS_ENABLED=1
	set AS_INSTALLED=1
	set AS_IS_SYSTEM=1
	set AS_ENABLED=1
	set API_INSTALLED=1
	set API_IS_SYSTEM=1
	set API_ENABLED=1
	set LM_INSTALLED=1
	set LM_IS_SYSTEM=1
	set LM_ENABLED=1
	set IMP_XML_INSTALLED=1
	set IMP_XML_IS_SYSTEM=1
	set IMP_XML_ENABLED=1
goto :EOF

:: ============================================================================
:: Environment Settings fr die verschiedenen Batch Dateien:
:Usage
	if defined _HAVE_OWN_HELP goto :EOF
	echo.
	echo : ============================================================================
	echo : Possible parameters for the most common scripts, what configure
	echo : the called programs from %_SQS_PRODUCT_NAME%:
	echo : ----------------------------------------------------------------------------
	echo : ^ ^ -d(ebug) ^ ^ ^ ^ ^ ^ show debug messages from the running script
	echo : ^ ^ -f(orce) ^ ^ ^ ^ ^ ^ take the default input and don't ask
	echo : ^ ^ -s(ilent) ^ ^ ^ ^ ^ supress output
	echo : ^ ^ -n ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ show how the program will be called
	echo : ^ ^ -e ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ ^ show and run the command
	echo : ^ ^ -ServerContext Name of selected environment (Default: %_SQS_DEFAULT_CONTEXT%)
	echo : ^ ^ -ProcessNumber Number of the process (Default: 1)
	echo : ^ ^ -LicenseFile ^ ^ (Default: %_SQS_LICENSE_FILE%)
	echo : ^ ^ -DBHost ^ ^ ^ ^ ^ ^ ^ LOCAL or Hostname/IP (Default: %_SQS_DB_HOST%)
	echo : ^ ^ -DBName ^ ^ ^ ^ ^ ^ ^ logical or physical name of the used database
	echo : ^ ^ -DBConfigFile ^ location of the database configuration (Default: '%SQS_CONFIG_DIR%\ptserver.cfg')
	echo : ^ ^ ...
	echo : ============================================================================
	echo.
goto :EOF
:: ============================================================================

:: ============================================================================
:: Zeige das partielle oder gesamte Environment an
:: ============================================================================
:ShowEnvironment
	if not defined _SQS_DEBUG goto :EOF
	if %_SQS_DEBUG% LEQ 3 goto NEXT_ENV
	echo.
	echo ----------------------------------------------------------------------------
	echo Actual windows environment:
	echo ----------------------------------------------------------------------------
	set
	echo ----------------------------------------------------------------------------
	echo.
	goto :EOF
	:NEXT_ENV
	if %_SQS_DEBUG% LEQ 2 goto :EOF
	set SQS
	set _SQS
	set PSQS
	set IT
	set PATH
goto :EOF

:: ==================================================================
:: Funktion ersetzt die Variable %1 durch den Wert von %4,
:: wenn der Wert von %2 gleich dem Wert von %3 ist.
:: Hierdurch wird die Ersetzung der Installation ausgetrickst, die
:: sonst alle Strings ersetzt, die zwischen zwei $-Zeichen stehen
:CheckInstalled 
	set __ACT_VALUE=%~3
	if not defined __ACT_VALUE goto :EOF
	if "%~2" EQU "%__ACT_VALUE:$=%" set %1=%~4
goto :EOF

:: ==================================================================
:: Falls es sich um eine Demoinstallation handelt, werden hier die CORBA
:: Domain und der Lizenzserver gestartet
:StartDemo
	if defined _SQS_DONT_START_DEMO goto :EOF
	if "%_SQS_DEMO_DOMAIN_DEF%" NEQ "%_SQS_DOMAIN_NAME%" goto :EOF

	call :DebugHeader %0 %*

	: Versuche Domaine zu starten
	set __SCRIPT=%IT_CONFIG_DIR%\bin\start_%_SQS_DOMAIN_NAME%_services.bat
	if exist "%__SCRIPT%" (
		call :Info Start CORBA domain '%_SQS_DOMAIN_NAME%'...
		call "%__SCRIPT%" 1> nul 2>&1
	) else (
		call :Warning CORBA domain '%_SQS_DOMAIN_NAME%' is not configured!
	)
	set __LMGRD=%SQS_INSTALL_DIR%\%_SQS_LIC_PACKAGE%\%_SQS_LIC_VERSION%\bin\lmgrd.exe
	if exist "%__LMGRD%" (
		call :Info Start license server...
		call "%__LMGRD%" -l "%SQS_NL_LOG_PATH%\DemoLicense.log" -c "%_SQS_LICENSE_FILE%" 1> nul 2>&1
	) else (
		call :Warning Can not start the license server!
	)
goto :EOF

:InitAliases
	set CallPrependPath=call "%~dpnx0" --run :PrependPath
	set CallRun=call         "%~dpnx0" --run :Run
	set CallInfo=call        "%~dpnx0" --run :Info
	set CallDebug=call       "%~dpnx0" --run :Debug
	set CallDebugHeader=call "%~dpnx0" --run :DebugHeader
	set CallWarning=call     "%~dpnx0" --run :Warning
	set CallError=call       "%~dpnx0" --run :Error
	set CallUpdate=call      "%~dpnx0" --run :SetUpdateWorkspacelist
	set CallProlog=call      "%~dpnx0" --run :ShowProlog
	set CallPreferHost=call  "%~dpnx0" --run :SetPreferHostnameInIOR true
	set CallPreferIP=call    "%~dpnx0" --run :SetPreferHostnameInIOR false
	set CallHostName=call    "%~dpnx0" --run :GetMyNames
	set CallDelTempVars=call "%~dpnx0" --run :DeleteTempVars
goto :EOF

:GetLocalHostname
	if defined %~1 	call :Debug : Local hostname(1): '%%%~1%%'
	if defined %~1 goto :EOF
	set __lh=
	call :GetHostName __lh
	if not defined __lh set __lh=localhost
	:: if not defined x set __lh=localhost
	set %~1=%__lh%
	call :Debug : Local hostname(2): '%%%~1%%'
goto :EOF

:GetHostname
	for /f %%i in ('hostname') do set %~1=%%i
	if not defined %~1 set %~1=%COMPUTERNAME%
goto :EOF

:: ==================================================================
:: Hilfsfunktionen:
:: * Check* berprfen ob Parameter 2 existiert und setzen %1 auf
::   den nicht gequoteten Wert
:: * Anzeigefunktionen
::   Geben die bergebenen Parameter aus, wenn der Filter es zulsst
:: * File kopieren
::   Kopiert mit Umlenkung der Standardausgaben
:: ==================================================================
:CheckDir
	if exist "%~2" set %1=%~dpnx2&goto :EOF
	if "%~3" EQU "1" call :Error Directory "%~2" doesn't exist!&set DIR_MISSING=1
goto :EOF

:CheckFile
	if exist "%~2" set %~1=%~dpnx2&goto :EOF
	if "%~3" EQU "1" call :Error File "%~2" doesn't exist!&set FILE_MISSING=1
goto :EOF

:CopyFile
	copy "%~1" "%~2" 1> nul 2>&1
	set COPY_ERROR=%ERRORLEVEL%
	if %COPY_ERROR% NEQ 0 call :Error Copy from "%~1" to "%~2" failed (Systemerror: %COPY_ERROR%).
goto :EOF

:Output
	if "%~1" EQU ".leer" echo.&goto :EOF
	if "%~2" EQU "RMQuotes" echo %~1&goto :EOF
	echo %*	
goto :EOF

:Info
	if defined _SQS_SILENT goto :EOF
	if "%~1" EQU "" echo Empty info message!&goto :EOF
	call :Output %*
goto :EOF

:Debug
	if not defined _SQS_DEBUG goto :EOF
	if "%~1" EQU "" echo Empty debug message!&goto :EOF
	call :Output %*
goto :EOF

:: Debug Ausgaben erst ab Stufe '2'
:Debug2
	if not defined _SQS_DEBUG goto :EOF
	if %_SQS_DEBUG% LSS 2 goto :EOF
	if "%~1" EQU "" echo Empty debug message!&goto :EOF
	call :Output %*
goto :EOF

:WARNING
	if not defined _SQS_SHOW_WARNIG goto :EOF
	if "%~1" EQU "" echo Empty warning message!&goto :EOF
	call :Output %*
goto :EOF

:ERROR
	if "%~1" EQU "" echo Empty error message!&goto :EOF
	call :Output %*
goto :EOF

:Run
	if "%~1" EQU "" echo Empty run command!&goto :EOF
	if defined _SQS_ECHO echo %*
	if not defined _SQS_ECHO call %*
	if defined _SQS_ECHO_AND_RUN call %* 
goto :EOF

:DebugExecute
	if not defined _SQS_DEBUG goto :EOF
	if "%~1" EQU "" echo Empty debug run command!&goto :EOF
	call %*
goto :EOF

:DebugHeader
	set __PARAM1=%*
	if "%__PARAM1:~0,1%" EQU ":" set "__PARAM1=%__PARAM1:~1%"
	call :Debug .leer
	call :Debug : ============================================================================
	call :Debug : Section: '%__PARAM1%'
goto :EOF

:GetProcName
	set __PARAM1=%1
	if "%__PARAM1:~0,1%" EQU ":" set "__PARAM1=%__PARAM1:~1%"
	set %~2=%__PARAM1%
goto :EOF

:: ==================================================================
:: Parameter %2 wird in Kleinbuchstaben konvertiert und Parameter %1
:: zugewiesen
:: ==================================================================
:toLower
	if "%~2" EQU "" goto :EOF
	set __result=%~2
	set __result=%__result:A=a%
	set __result=%__result:B=b%
	set __result=%__result:C=c%
	set __result=%__result:D=d%
	set __result=%__result:E=e%
	set __result=%__result:F=f%
	set __result=%__result:G=g%
	set __result=%__result:H=h%
	set __result=%__result:I=i%
	set __result=%__result:J=j%
	set __result=%__result:K=k%
	set __result=%__result:L=l%
	set __result=%__result:M=m%
	set __result=%__result:N=n%
	set __result=%__result:O=o%
	set __result=%__result:P=p%
	set __result=%__result:Q=q%
	set __result=%__result:R=r%
	set __result=%__result:S=s%
	set __result=%__result:T=t%
	set __result=%__result:U=u%
	set __result=%__result:V=v%
	set __result=%__result:W=w%
	set __result=%__result:X=x%
	set __result=%__result:Y=y%
	set __result=%__result:Z=z%
	set __result=%__result:=%
	set __result=%__result:=%
	set __result=%__result:=%
	set %1=%__result%
	call :Debug : %~0: '%~2': '%__result%'
goto :EOF

:: ==================================================================
:: Parameter %2 wird in Grobuchstaben konvertiert und Parameter %1
:: zugewiesen
:: ==================================================================
:toUpper
	if "%~2" EQU "" goto :EOF
	set __result=%~2
	set __result=%__result:a=A%
	set __result=%__result:b=B%
	set __result=%__result:c=C%
	set __result=%__result:d=D%
	set __result=%__result:e=E%
	set __result=%__result:f=F%
	set __result=%__result:g=G%
	set __result=%__result:h=H%
	set __result=%__result:i=I%
	set __result=%__result:j=J%
	set __result=%__result:k=K%
	set __result=%__result:l=L%
	set __result=%__result:m=M%
	set __result=%__result:n=N%
	set __result=%__result:o=O%
	set __result=%__result:p=P%
	set __result=%__result:q=Q%
	set __result=%__result:r=R%
	set __result=%__result:s=S%
	set __result=%__result:t=T%
	set __result=%__result:u=U%
	set __result=%__result:v=V%
	set __result=%__result:w=W%
	set __result=%__result:x=X%
	set __result=%__result:y=Y%
	set __result=%__result:z=Z%
	set __result=%__result:=%
	set __result=%__result:=%
	set __result=%__result:=%
	set %1=%__result%
	call :Debug : %~0: '%__result%'
goto :EOF

:ShowHeader
	if defined _CALLER set _SQS_TEMP=%_CALLER%
	if not defined _CALLER set _SQS_TEMP=Called with parameter:
	call :Info
	call :Info : ================================================================
	call :Info : %_SQS_TEMP% %*
	call :Info : Started: %DATE% %TIME%
	call :Info : ================================================================
goto :EOF

:: ============================================================================
:: Zeitstempel als String merken, den man in Datei- und Pfadnamen verwenden kann
:: ============================================================================
:GetTimeString
	set __TIMESTRG=%DATE%-%TIME%
	: Millisekunden entfernen
	set __TIMESTRG=%__TIMESTRG:~0,-3%
	: Wochentage (deutsch/Englisch) entfernen falls sie da sind
	set __TIMESTRG=%__TIMESTRG:Mon =%
	set __TIMESTRG=%__TIMESTRG:Tue =%
	set __TIMESTRG=%__TIMESTRG:Wed =%
	set __TIMESTRG=%__TIMESTRG:Thu =%
	set __TIMESTRG=%__TIMESTRG:Fri =%
	set __TIMESTRG=%__TIMESTRG:Sat =%
	set __TIMESTRG=%__TIMESTRG:Son =%
	set __TIMESTRG=%__TIMESTRG:Mon =%
	set __TIMESTRG=%__TIMESTRG:Die =%
	set __TIMESTRG=%__TIMESTRG:Mit =%
	set __TIMESTRG=%__TIMESTRG:Don =%
	set __TIMESTRG=%__TIMESTRG:Fre =%
	set __TIMESTRG=%__TIMESTRG:Sam =%
	set __TIMESTRG=%__TIMESTRG:Son =%
	: Blanks entfernen
	set __TIMESTRG=%__TIMESTRG: =0%
	: Sonderzeichen, die in Pfaden Probleme machen entfernen
	set __TIMESTRG=%__TIMESTRG:\=%
	set __TIMESTRG=%__TIMESTRG:/=%
	set __TIMESTRG=%__TIMESTRG:.=%
	set __TIMESTRG=%__TIMESTRG::=%
	set __TIMESTRG=%__TIMESTRG:,=%
	set %1=%__TIMESTRG%
	call :Debug : %0: '%%%1%%'
goto :EOF

: ============================================================================
: Falls die Variable _SQS_CONFIGURE_TPA_SERVER gesetzt ist, trage den Server
: in den CORBA Kontext Scope ein.
: ============================================================================
:ConfigureTPAServer
	if not defined _SQS_CONFIGURE_TPA_SERVER goto NOTHING_TODO
	if not defined _DOMAIN_IS_ACTIVE call :Error ERROR: Can not check, because domain '%IT_DOMAIN_NAME%' is not running!&goto NOTHING_TODO
	: Sicherheitshalber wird zuerst der Scope angelegt und die Variable gelscht,
	: damit das 'create' nicht schiefgehen kann
	call "%IT_ADMIN%" scope create SQS.%SQS_SERVER_CONTEXT% 1> nul 2>&1
	call "%IT_ADMIN%" variable remove -scope SQS.%SQS_SERVER_CONTEXT% TPAServer 1> nul 2>&1
	if not defined SQS_TPA_SERVER (
		call :Info TPA server is not defined, so an existing setting will be deleted!
		goto NOTHING_TODO
	)
	call "%IT_ADMIN%" variable create -scope SQS.%SQS_SERVER_CONTEXT% -type string -value "%SQS_TPA_SERVER%" TPAServer
	:NOTHING_TODO
	call :Debug : TPA server settings for workspace environment '%SQS_SERVER_CONTEXT%': '%SQS_TPA_SERVER%'
	if defined _DOMAIN_IS_ACTIVE call :DebugExecute "%IT_ADMIN%" variable show -scope SQS.%SQS_SERVER_CONTEXT% TPAServer
goto :EOF


: ============================================================================
: Ermittle die Lnge des Parameter 1 und gib sie in Parameter 2 zurck
: ============================================================================
:StrgLength
	: Get the length of a string
	setlocal & set TmpCnt=%~1
	if not defined TmpCnt (
		set StrLen=0
	) else (
		: Lsche solange das erste Zeichen der Variablen,
		: bis die Variable leer ist
		:Lenloop
		set TmpCnt=%TmpCnt:~1%
		set /a StrLen +=1
		if defined TmpCnt goto Lenloop
	)
	endlocal & set %2=%StrLen%
goto :EOF

: ============================================================================
: Addiere soviele fhrende Nullen an Parameter 2, wie in Parameter 1 vor-
: gegeben sind gib den vernderten Inhalt ber Parameter 3 zurck
: ============================================================================
:GetNumberStrg
	call :Debug : %0 %*
	call :StrgLength %2 __Length
	call :Debug : ProcessNumber Lenght = %__Length%

	if "%__Length%" EQU "" set %3=0&goto :EOF
	if "%__Length%" GEQ "%1" goto :EOF

	set __XXX=0%2
	call :GetNumberStrg %1 %__XXX% %3
	set %3=%__XXX%
goto :EOF


:TPAConfig
	set __CONF=%~1
	set __CONF=%__CONF:Env.=Env-TPA.%
	if exist "%__CONF%" call "%__CONF%"
goto :EOF

:SetIt
	set %~1=%~2
goto :EOF

:SetDefault
	: Wurde ein Parameter bergeben nimm den Wert von diesem Parameter
	if defined _%~1 call :SetIt %~1 "%%_%~1%%"&goto SetDefaultEnd

	: Feststellen, ob Variablen gesetzt wurden, sonst mit Defaults arbeiten
	: z.B. fr GetBaseline
	set _PARAM=%~2
	if defined _PARAM if "%_PARAM:~0,1%%_PARAM:~-1%" EQU "$$" if "%~3" NEQ "" call :SetIt %1 %3&goto SetDefaultEnd
	: echo '%_PARAM:~0,1%%_PARAM:~-1%'
	
	: Wurde kein Parameter bergeben verndere den Wert nur,
	: wenn er nicht bereits gesetzt ist
	if not defined %~1 call :SetIt %~1 %2
	:SetDefaultEnd
	call :GetProcName %~0 PROC_NAME
	call :Debug2 : %PROC_NAME%: %~1 = '%%%~1%%' ^['%~3'^]
goto :EOF

:SetDefaultPath
	: Wurde ein Parameter bergeben nimm den Wert von diesem Parameter
	if defined _%~1 call :SetIt %~1 "%%_%~1%%"&goto SetDefaultPathEnd

	: Feststellen, ob Variablen gesetzt wurden, sonst mit Defaults arbeiten
	: z.B. fr GetBaseline
	set _PARAM=%~2
	if "%_PARAM:~0,1%%_PARAM:~-1%" EQU "$$" if "%~3" NEQ "" call :SetIt %1 %3&goto SetDefaultPathEnd
	
	: Wurde kein Parameter bergeben verndere den Wert nur,
	: wenn er nicht bereits gesetzt ist
	if not defined %~1 call :SetIt %~1 %2

	:SetDefaultPathEnd
	call :CheckThisPath %1 __DONT_EXIST
	if defined __DONT_EXIST goto LeaveIt

	call :MakeShortPath %1 "%%%~1%%"
	call :NormalizePath "%%%~1%%" %1
	:LeaveIt
	call :GetProcName %~0 PROC_NAME
	call :Debug : %PROC_NAME%: %~1 = '%%%~1%%' ^['%~3'^]
goto :EOF

:CheckThisPath
	set %~2=
	call set __CHECK_THIS_PATH=%%%~1%%
	if not exist "%__CHECK_THIS_PATH%" set %~2=1&call :Error '%%%~1%%' ^[%~1^] don't exist!
goto :EOF

:NormalizePath
	:: UNC Pfade werden nicht normalisiert
	set _PARAM=%~1
	if "%_PARAM:~0,2%" EQU "\\" set %~2=%~1&call :Debug : Don't normalize UNC path.&goto :EOF

	pushd %1 1> nul 2>&1
	if "%ERRORLEVEL%" NEQ "0" call :Error %0: %2 '%~1'&goto :EOF
	set %~2=%CD%
:	echo %~0: '%CD%'
	popd 1> nul 2>&1
goto :EOF

:SetUpdateWorkspacelist
	if not defined SQS_SERVER_CONTEXT goto __ERROR
	call "%IT_ADMIN%" variable modify -scope SQS.%SQS_SERVER_CONTEXT%.Server -type string -value 1 Workspaces:updated 1> nul 2>&1
	if "%ERRORLEVEL%" EQU "0" goto :EOF
	:__ERROR
	%CallInfo% Could not modify 'Workspaces:updated' in scope 'SQS.%SQS_SERVER_CONTEXT%.Server'.
goto :EOF

:SetPreferHostnameInIOR
	setlocal
	set _VAR=policies:iiop:server_address_mode_policy:publish_hostname
	if not defined _DOMAIN_IS_ACTIVE call :Warning Can not set variable '%_VAR%' because domain '%IT_DOMAIN_NAME%' is not running!&goto :EOF

	if /i "%~1" EQU "false" call "%IT_ADMIN%" variable remove -scope SQS %_VAR% 1> nul 2>&1&goto :EOF
	call "%IT_ADMIN%" variable modify -scope SQS -type bool -value true %_VAR% 1> nul 2>&1
	if "%ERRORLEVEL%" EQU "0" %CallDebug% Set '%_VAR%' in scope 'SQS' to %~1&goto :EOF
	%CallInfo% Could not modify '%_VAR%' in scope 'SQS'.
	endlocal
goto :EOF

:ShowExistingIORs
	call :DebugHeader %0: '%*'
	setlocal
	if not exist "%IT_ADMIN%" echo : During installation and/or configuration issues the domains naming service content could not be analyst.&goto :EOF
	set ROOT_NS=%SQS_SERVER_CONTEXT%/
	set HEADER_MSG=Environment '%SQS_SERVER_CONTEXT%' contain this public CORBA references:
	if not defined SQS_SERVER_CONTEXT set ROOT_NS=/&set HEADER_MSG=Domain '%IT_DOMAIN_NAME%' contain this public CORBA references:
	call :BuildTempFile _TEMP_FILE
	set __NSPATH=
	:: @echo on
	@call "%IT_ADMIN%" ns list -rec %ROOT_NS% > "%_TEMP_FILE%"
	@echo off
	type "%_TEMP_FILE%"
	echo '%_TEMP_FILE%'
	echo.
	echo %HEADER_MSG%
	echo ------------------------------------------------------------------------
	for /f "tokens=1,2,3 delims=^|" %%i in ('type "%_TEMP_FILE%"') do call :GetNSName "%%~i" "%%~j" "%%~k"
	::del "%_TEMP_FILE%" 1>nul 2>&1
	endlocal
goto :EOF

:GetNSName
	call :DebugHeader %0: '%*'
	::Laut Format sind immer 2 von Dreien undefiniert nach dem :SetVar Aufruf
	call :SetVar __PARAM1 %~1
	call :SetVar __PARAM2 %~2
	call :SetVar __PARAM3 %~3
	call :Debug : %0: 1:'%__PARAM1%' 2:'%__PARAM2%' 3:'%__PARAM3%'
	if "%__PARAM:~,1%" EQU "-" call :SetNSPATH &goto :EOF
	if defined __PARAM1 set _IOR_NAME=%__PARAM%
	if defined __PARAM2 set _IOR_NAME=%__NSPATH1%%__PARAM%
	if defined __PARAM3 set _IOR_NAME=%__NSPATH1%%__NSPATH2%%__PARAM%
	call :Debug : Try resolve '%_IOR_NAME%'...
	for /f %%i in ('"%IT_ADMIN%" ns resolve %_IOR_NAME%') do set _IOR=%%i
	call :Debug : Found IOR '%_IOR%'
	if "%_IOR:~,4%" EQU "IOR:" (
		call :ResolveHostFromIOR %_IOR% _HOST
		call :ResolvePortFromIOR %_IOR% _PORT
		call echo : %_HOST%@%_PORT%: address of IOR from name '%_IOR_NAME%'
	) else (
		echo Unknown address format of IOR from '%_IOR_NAME%': '%_IOR%'
	)
goto :EOF

:SetNSPATH
	call :RemoveLeadingChar __PARAM -
	if defined __PARAM1 set __NSPATH1=%__PARAM%/&set __NSPATH=%__PARAM%/
	if defined __PARAM2 set __NSPATH2=%__PARAM%/&set __NSPATH=%__NSPATH1%%__PARAM%/
	if defined __PARAM3 set __NSPATH3=%__PARAM%/&set __NSPATH=%__NSPATH1%%__NSPATH2%%__PARAM%/
	call :Debug : NS Path: '%__NSPATH%' ('%__NSPATH1%', '%__NSPATH2%', '%__NSPATH3%')
goto :EOF

:ResolveHostFromIOR
	call :DebugHeader %0: '%*'
	call :BuildTempFile __TEMP_FILE
	call "%IOR_DUMP%" %~1 | grep "Host string" > "%__TEMP_FILE%"
	for /f "tokens=1,2 delims=^'" %%i in ('grep "Host string" "%__TEMP_FILE%"') do call :SetVar %~2 %%j
	del "%__TEMP_FILE%" 1>nul 2>&1
	call :Debug : Host: '%%%~2%%'
goto :EOF

:ResolvePortFromIOR
	call :BuildTempFile __TEMP_FILE
	call "%IOR_DUMP%" %~1 | grep "Port" > "%__TEMP_FILE%"
	for /f "tokens=1,2 delims=: " %%i in ('grep "Port" "%__TEMP_FILE%"') do call :SetVar %~2 %%j
	del "%__TEMP_FILE%" 1>nul 2>&1
	call :Debug : Port: '%%%~2%%'
goto :EOF

:SetVar
	setlocal
::	echo %0: '%*'
	set __VAR=%~2
	::if not defined __VAR goto :EOF
	call :RemoveTrailingChar __VAR " "
	call :RemoveLeadingChar __VAR " "
	call :RemoveTrailingChar __VAR .
	endlocal&set %~1=%__VAR%
	if defined %~1 call set __PARAM=%%%~1%%
goto :EOF

:RemoveLeadingChar
	setlocal
	call set _VALUE=%%%~1%%
	set _CHAR=%~2
::	echo %0: '%_VALUE%' '%_CHAR%'
	if not defined _CHAR goto :EOF
	if not defined _VALUE goto :EOF
	if "%_VALUE:~,1%" EQU "%_CHAR%" call set _VALUE=%_VALUE:~1%&call :RemoveLeadingChar _VALUE "%_CHAR%"
	endlocal&set %~1=%_VALUE%
goto :EOF

:RemoveTrailingChar
	setlocal
	call set _VALUE=%%%~1%%
	set _CHAR=%~2
	if not defined _CHAR goto :EOF
	if not defined _VALUE goto :EOF
	if "%_VALUE:~-1,1%" EQU "%_CHAR%" call set _VALUE=%_VALUE:~0,-1%&call :RemoveTrailingChar _VALUE "%_CHAR%"
	endlocal&set %~1=%_VALUE%
goto :EOF

:ShowProlog
	:: Wenn das Programm und die Textdatei existiert, fhre es aus.
	::   Gibt es ein eigenes Programm im Config-Verzeichnis
	set INFO_VIEWER=%SQS_CONFIG_DIR%\InfoViewer.exe
	if not exist "%INFO_VIEWER%" set INFO_VIEWER=InfoViewer.exe
	::   Oder nehme ich das installierte
	if not exist "%INFO_VIEWER%" goto :EOF

	:: berprfe hier, ob es eine Infodatei fr den Kontext in der Domne gibt
	:: Die mglichen Formate sind HTML und normaler ASCII Text.
	set _PROLOG=%SQS_CONFIG_DIR%\%SQS_SERVER_CONTEXT%-%_SQS_CORBA_HOST%.htm
	if not exist "%_PROLOG%" set _PROLOG=%SQS_CONFIG_DIR%\%SQS_SERVER_CONTEXT%-%_SQS_CORBA_HOST%.html
	if not exist "%_PROLOG%" set _PROLOG=%SQS_CONFIG_DIR%\%SQS_SERVER_CONTEXT%-%_SQS_CORBA_HOST%.txt
	if not exist "%_PROLOG%" goto :EOF

	call "%INFO_VIEWER%" "%_PROLOG%"
goto :EOF

:SetLocalEnv
	if exist LocalEnv.bat (
		call :DebugHeader %0 %*
		call LocalEnv.bat
		call :DebugExecute type LocalEnv.bat ^| grep -w set
	) else (
		set SQS_PRODUCT_PATCH=$NL_patchstring$
		set SQS_DATA_ROOT=$NL_data_root$
		set SQS_CTX_ACCESS=$NL_ctx_access$
	)
goto :EOF

:CheckCOMEnv
	if not defined _SQS_CKECK_COMENV goto :EOF
	call :DebugHeader %0 %*
	:: Wird hier gesetzt, damit die COMet Clients in der Umgebung die richtige Domaine auswhlen.
	setenv -v IT_CONFIG_DOMAINS_DIR "%IT_CONFIG_DOMAINS_DIR%" 1>nul 2>&1
	setenv -v IT_DOMAIN_NAME "%IT_DOMAIN_NAME%" 1>nul 2>&1
goto :EOF
