@echo off
:: Anzeige aller Versionen in der aktuellen View
setlocal
set _LOCAL_ENV=%~dp0Environment-Defaults.bat
: ============================================================================
: Basis Settings des bentigten Environments
: Es wird davon ausgegangen, dass sich der aufgerufene Batch im gleichen 
: Verzeichnis befindet
: ============================================================================
if exist "%_LOCAL_ENV%" call "%_LOCAL_ENV%" %* -version

if exist "%TEMP%" set "TEMPLOG=%TEMP%\~ActVersion"
if not exist "%TEMP%" set "TEMPLOG=~ActVersion"
set /a _COUNTER=0

call :ServerVersion MS -VersionInfo ManagementServer.exe
call :ServerVersion AS -VersionInfo ApplicationServer.exe
call :ServerVersion API -VersionInfo APIServer.exe
call :ServerVersion IMP_XML -VersionInfo ImportManagerXML.exe
call :ServerVersion LM -VersionInfo LicenseManager.exe
call :ServerVersion IS_CASE -VersionInfo IntegrationManagerCASE.exe
call :ServerVersion IS_BPM -VersionInfo IntegrationManagerBPM.exe

set _NORMAL_FILTER=Version

set /a _COUNTER+=1
call :VersionFilter Client.exe -verbose

set /a _COUNTER+=1
setlocal
set _SQS_FIRST_TIME=
call :VersionFilter AdminClient.bat -fi -v  -s
endlocal

UpdateManager.exe -Verbose
CheckDb.exe -Verbose
DbAdmin.exe -Verbose
DBEdit.exe -Verbose

set /a _COUNTER+=1
call :VersionFilter WorkspacePropagator.exe -VersionInfo 

set /a _COUNTER+=1
setlocal
set _SQS_FIRST_TIME=
set _MY_FILTER=Testlog-Editor
call :VersionFilter "%~dp0TestlogEdit.bat" -V
endlocal

set /a _COUNTER+=1
call :VersionFilter PropagationEditor.exe -verbose
echo.
call :TPAVersion
echo.
call :ServerVersion MS -InterfaceInfo ManagementServer.exe

if defined _SQS_NO_INTERACTION goto ENDE
echo.
pause

:ENDE
endlocal
goto :EOF


:VersionFilter
	call set _LOG=%TEMPLOG%-%_COUNTER%.txt
	set _FILTER=%_NORMAL_FILTER%
	if defined _MY_FILTER set _FILTER=%_MY_FILTER%&set "_MY_FILTER="
::	echo %* %_LOG%
	call %* 1> %_LOG% 2>&1
	grep -i %_FILTER% %_LOG%
	del %_LOG% 1> nul 2>&1
goto :EOF

:ServerVersion
	if defined %1_IGNORE goto :EOF
	set EXE=%~3
	if exist "x64\%~3" set EXE=x64\%~3
	if not exist %3 goto :EOF
	"%EXE%" %2 -verbose -NoLogFile | grep Version
goto :EOF

:TPAVersion
	setlocal
	set POST_FIX=
	set TPA_INSTALL_DIR=%SQS_INSTALL_DIR%\wl\%_SQS_PRODUCT_MAJOR%.%_SQS_PRODUCT_MINOR%
	if not exist "%TPA_INSTALL_DIR%" set TPA_INSTALL_DIR=%SQS_INSTALL_DIR%\wl\%_SQS_PRODUCT_VERSION%
	set VERSION_FILE=%TPA_INSTALL_DIR%\ppm\WEB-INF\web.xml
	if not exist "%TPA_INSTALL_DIR%" echo No TPA Installation found at '%TPA_INSTALL_DIR%'&goto :EOF
	if exist "%VERSION_FILE%" goto :EvalXML

	set VERSION_FILE=%TPA_INSTALL_DIR%\ppm\WEB-INF\build.number
	if not exist "%VERSION_FILE%" echo "No TPA Version found" &goto :EOF
	for  /f "tokens=2 delims=="  %%i in ('grep build.number= "%VERSION_FILE%"') do set _VERSION=%_SQS_PRODUCT_VERSION%.%%i
	set POST_FIX=(eine Nummer kleiner)
	goto :PrintTPAVersion
:EvalXML	
	: Komplette Versionsnummer steht in der gefundenen Zeile an dritter Position
	for /f "tokens=3" %%i in ('grep "Internal version" "%VERSION_FILE%"') do set _VERSION=%%i
	
:PrintTPAVersion
	echo TPA Server        Version %_VERSION% %POST_FIX%
	endlocal
goto :EOF
